Package: timecourse
Version: 1.83.0
Date: 2007-6-3
Title: Statistical Analysis for Developmental Microarray Time Course
        Data
Author: Yu Chuan Tai 
Maintainer: Yu Chuan Tai <yuchuan@stat.berkeley.edu>
Depends: R (>= 2.1.1), MASS, methods
Imports: Biobase, graphics, limma (>= 1.8.6), MASS, marray, methods,
        stats
Description: Functions for data analysis and graphical displays for developmental microarray time course data.
License: LGPL
URL: http://www.bioconductor.org
biocViews: Microarray, TimeCourse, DifferentialExpression
git_url: https://git.bioconductor.org/packages/timecourse
git_branch: devel
git_last_commit: 7b6e6b3
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:26:25 UTC; biocbuild

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004
## Last Modified: Feb. 15, 2005

## Helmert Matrix

ot.helmert <- function(k)
{

    if(missing(k)) stop("The number of time points is missing.")

    if (is.numeric(k) && length(k) == 1)
          if(k > trunc(k)) stop("The number of time points is not an integer.")

    
    levels <- 1:k

    T0 <- matrix(rep(1/sqrt(k), k), byrow=TRUE, ncol=k)

    T1 <- matrix(rep(0,(k-1)*k), ncol=k, byrow=TRUE)
    T1 <- array(1/sqrt(diag(outer(row(T1)[,1]+1, row(T1)[,1], "*"))),c(k-1,k))
    T1[col(T1) > row(T1)] <- 0
    T1[col(T1) == row(T1)+1] <- -(row(T1)[,1])/sqrt(diag(outer(row(T1)[,1]+1, row(T1)[,1], "*")))

    OT <- rbind(T0, T1)

    OT
}

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004
## Last Modified: July 16, 2005

    
mb.paired <- function(object, k, mn, nu=NULL, Lambda=NULL, eta=NULL,
c.grp=NULL, k.grp=NULL, n.grp=NULL, one.D=FALSE, reference=NULL, r=FALSE, vec=FALSE, d=NULL, prop=0.02, 
T2.only=TRUE)
{

    res <- as.list(NULL)
    M <- NULL
    geneNames <- desc <- NULL
     if (is(object, "MAList") || is(object, "list"))
          M <- object$M

    if (is(object, "marrayNorm"))
    {
          M <- object@maM
          geneNames <- rownames(M)             
          desc <- object@maGnames@maLabels
    }

    if (is(object, "ExpressionSet"))
    {
          M <- exprs(object)
          geneNames <- rownames(M)       
    }

     if (is.null(M))
        M <- as.matrix(object)

    G <- nrow(M)
    if(missing(k)) stop("The number of time points is missing.")
    if(missing(mn)) stop("The sample sizes are missing.")
    if(one.D) 
    {
       max.mn <- ncol(M)/k
       if(!is.null(mn)) mn <- as.matrix(mn)
       if(!is.null(mn) & nrow(mn) !=G) stop("The sample sizes are incorrect.")

       if(is.null(c.grp)) 
       {
            c.grp <- rep(1, ncol(M))
            cat("Condition group assignments are set to default.","\n")
       }
       if(length(unique(c.grp)) != 1) stop("The biological condition group assignments are incorrect!")
       if(is.null(k.grp)) 
       {
            k.grp <- rep(1:k, max.mn)
            cat("Time group assignments are set to default.","\n")
       }
       if(length(unique(k.grp)) != k) 
            stop("Error in the number of time points or the time group assignments!")
       if(is.null(n.grp)) 
       {    
            n.grp <- rep(c(1:max.mn), rep(k, max.mn))
            cat("Replicate group assignments are set to default.","\n")
       }
       if(length(unique(n.grp)) != max.mn) 
             stop("Error in the sample size or the replicate group assignments.")
     }

    if(!one.D) 
    {
       max.mn <- ncol(M)/k/2
       #if((is.null(mn) || sum(is.na(mn))>0) & is.null(c.grp)) stop("The sample sizes are missing!")
       
       if(!is.null(mn) & !is.null(c.grp)) 
       {
          if(length(unique(c.grp)) != 2) stop("Error in biological condition group assignments!") 
          if(ncol(mn) != length(unique(c.grp))) stop("Error in sample sizes!")
          if(sum(mn[,1]!=mn[,2])>0) stop("Some genes have unequal sample sizes.")
          if(((max.mn*k) != sum(c.grp==unique(c.grp)[1])) || 
                         ((max.mn*k) != sum(c.grp==unique(c.grp)[2])))
                   stop("Error in sample sizes or biological condition group assignments!")
       } 
     
       if(is.null(c.grp)) 
       {
            c.grp <- rep(c(1,2), each=max.mn*k)
            cat("Condition group assignments are set to default.","\n")
       }
       if(length(unique(c.grp)) != 2) stop("The biological condition group assignments are incorrect!")
       if(is.null(k.grp)) 
       {
             k.grp <- rep(1:k, ncol(M)/k)
             cat("Time group assignments are set to default.","\n")
       }
       if(length(unique(k.grp)) != k) 
             stop("Error in the number of time points or the time group assignments!")
       if(is.null(n.grp)) 
       {
             n.grp <- rep(c(1:max.mn,1:max.mn), rep(k, ncol(M)/k))
             cat("Replicate group assignments are set to default.","\n")
       }
       if(length(unique(n.grp)) != max.mn) 
             stop("Error in the sample sizes or the replicate group assignments!")
       if(is.null(reference)) reference <- c.grp[1]
     }
   
   mydata <- M
   indx <- order(c.grp, n.grp, k.grp)
   M <- M[,indx]

   mis <- apply(!apply(M, 1, is.na), 2, sum)
   mis <- sum((mis/k-floor(mis/k)) !=0)
   if(mis>0) stop(mis, " genes may have missing values in some of the replicates.")


   if(!one.D)  M <- t(apply(M, 1, abs2ratio, mn, k, c.grp, reference))
   
     S <- apply(M, 1, matrix.cov, k, trans=FALSE, c.grp=rep(1,ncol(M)))
     diagS <- apply(S, 2, function(x) diag(matrix(x,ncol=k))) 
     S.avg <- matrix(apply(S, 1, mean, na.rm=TRUE),ncol=k)
  

   if(is.null(nu)||is.null(Lambda))
   {

   nu.lim <- k+6
   
   if(!is.null(nu)) 
   {
     nu0 <- nu
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu) & is.null(Lambda) )  {Lambda <- S.avg} 
     if(is.finite(nu)& is.null(Lambda))    {Lambda <- (nu-k-1)*S.avg/nu}
     nu<- nu0
   }

   if(is.null(nu))
   {
     nu0 <- mean(sapply(1:k, function(x) squeezeVar(diagS[x,], mn[,1]-1)$df.prior))
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu)& is.null(Lambda))  {Lambda <- S.avg} 
     if(is.finite(nu)& is.null(Lambda))    {Lambda <- (nu-k-1)*S.avg/nu}
     nu <- nu0
   }
   }
   max.n <- max(mn[,1])
   xbar <- apply(M, 1, function(x) apply(matrix(x,  byrow=FALSE, ncol=max.n),1,mean,na.rm=TRUE))
   if(r)
   {
        e <- sapply(1:G, function(x) matrix(M[x,], byrow=FALSE, ncol=max.n)-xbar[,x])
        tune <- sapply(1:G, function(x) d * median(abs(e[, x]),na.rm = TRUE)/0.6745)
        indx <- sapply(1:G, function(x) abs(e[, x]) > tune[x])
        na.indx <- sapply(1:G, function(x) c(1:(k * max.n))[!is.na(indx[,x])])
        wt <- matrix(rep(1, G * max.n * k), ncol = max.n * k)
        wt <- t(sapply(1:G, function(x) {wt[x,][-na.indx[,x]] <- 0
              wt[x,]}))
        wt <- t(sapply(1:G, function(x) {wt[x, ][na.indx[,x]][indx[,x][na.indx[,x]]] <-
        tune[x]/abs(e[,x][na.indx[,x]][indx[,x][na.indx[,x]]])
        wt[x,]}))
        totalw <- sapply(1:G, function(x) apply(matrix(wt[x,], byrow=FALSE, ncol=max.n), 1, sum,
        na.rm=TRUE))
        w <- sapply(1:G, function(x) matrix(wt[x,], byrow=FALSE, ncol=max.n)/totalw[,x])
        xbar <- sapply(1:G, function(x)
        apply(matrix(w[, x] * M[x, ], byrow = FALSE, ncol = max.n),1, sum,na.rm=TRUE))



    }


   tol <- .Machine$double.eps
   if(is.finite(nu) & nu > tol) 
   {
     modS <- sapply(1:G, function(x) ((mn[x,1]-1)*matrix(S[,x],ncol=k)+nu*Lambda)/(mn[x,1]-1+nu))
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modS <- apply(modS, 2, function(x) 
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v)) 
     modt <- sapply(1:G, function(x) mn[x,1]^(1/2)*solve(matrix(sqrt.modS[,x],ncol=k))%*%xbar[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x) mn[x,1]*t(xbar[,x])%*%solve(matrix(modS[,x],ncol=k))%*%xbar[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x) mn[x,1]*t(xbar[,x])%*%solve(matrix(modS[,x],ncol=k))%*%xbar[,x])
   }
   if(is.infinite(nu))
   {
     modS <- sapply(1:G, function(x) Lambda)
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modS <- apply(modS, 2, function(x)
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v))
     modt <- sapply(1:G, function(x) mn[x,1]^(1/2)*solve(matrix(sqrt.modS[,x],ncol=k))%*%xbar[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     }
     if(T2.only) 
     HotellingT2 <- sapply(1:G, function(x) 
        mn[x,1]*t(xbar[,x])%*%solve(matrix(modS[,x],ncol=k))%*%xbar[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x) mn[x,1]*t(xbar[,x])%*%solve(matrix(modS[,x],ncol=k))%*%xbar[,x])
   }
   if(nu < tol & nu >=0)           
   {
     modS <- S
     if(is.null(eta) & (T2.only==FALSE))
     {                                                     
     sqrt.modS <- apply(modS, 2, function(x)
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v))
     modt <- sapply(1:G, function(x) mn[x,1]^(1/2)*ginv(matrix(sqrt.modS[,x],ncol=k))%*%xbar[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     } 
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
     mn[x,1]*t(xbar[,x])%*%ginv(matrix(modS[,x],ncol=k))%*%xbar[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x) mn[x,1]*t(xbar[,x])%*%ginv(matrix(modS[,x],ncol=k))%*%xbar[,x])

   }

   # HotellingT2 does not require eta
   if(is.null(eta) & (T2.only==FALSE)) eta <- mean(sapply(1:k, function(x) tmixture.matrix(modt[x,], 
   sqrt(mn[,1])^(-1), mn[,1]+nu-1, prop, c(0.1, 4)^2/Lambda[x,x]))^(-1)) 
   res$M <- mydata
   res$prop <- prop
   res$nu <- nu
   res$Lambda <- Lambda
   res$eta <- eta

 
  if(nu < 0) stop("The estimation of prior degrees of freedom <0 !")
   
   if(is.finite(nu) & nu > tol)
   {
      MB <- NULL
      if(T2.only==FALSE)
      {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- (k/2)*log((eta/(mn[,1]+eta)),10)
      MB3 <- ((mn[,1]+nu)/2)*log(((mn[,1]-1+nu+HotellingT2)/(mn[,1]-1+nu+(eta/(mn[,1]+eta))*HotellingT2)), 10)
      MB <- MB1+MB2+MB3
      }
      unique.mn <- unique(mn[,1])
      res$percent <- matrix(c(unique.mn, round(100*nu/(nu+unique.mn-1))), ncol=2)
      res$size <- mn
      res$con.group <- c.grp
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt <- modt
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }

   if(is.infinite(nu))
   {
      MB <- NULL
      if(T2.only==FALSE)
      {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- (k/2)*log((eta/(mn[,1]+eta)),10)
      MB3 <- 0.5*(mn[,1]/(mn[,1]+eta))*HotellingT2-log(10)
      MB <- MB1+MB2+MB3
      }
      unique.mn <- unique(mn[,1])
      res$percent <- matrix(c(unique.mn, 100), ncol=2)
      res$size <- mn
      res$con.group <- c.grp
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt <- modt  
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }

   if(nu < tol & nu >=0)
   {
       MB <- NULL
       if(T2.only==FALSE)
       {
       MB1 <- log(prop,10)-log(1-prop,10)
       MB2 <- (k/2)*log((eta/(mn[,1]+eta)),10)
       MB3 <- (mn[,1]/2)*log(((mn[,1]-1+HotellingT2)/(mn[,1]-1+(eta/(mn[,1]+eta))*HotellingT2)), 10)
       MB <- MB1+MB2+MB3
       }
      unique.mn <- unique(mn[,1])
      res$percent <- matrix(c(unique.mn, 0), ncol=2)
      res$size <- mn
      res$con.group <- c.grp
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt <- modt 
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }

   res$pos.HotellingT2 <- order(HotellingT2, decreasing = TRUE)
   if(!is.null(MB)) res$pos.MB <- order(MB, decreasing = TRUE)
   res$reference <- reference
   res$geneNames <- geneNames
   res$descriptions <- desc
   new("MArrayTC", res)

}

#  ZZZ.R

.First.lib <- function(libname, pkgname, where)
{
      if(.Platform$OS.type == "windows" && interactive() &&
         .Platform$GUI ==  "Rgui"){
        addVigs2WinMenu("timecourse")
    }
}

## Main function for 1-sample and 2-sample longitudinal microarray time course data analysis
## Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004
## Last Modified: August 14, 2005


mb.long <- function(object, method=c("1D", "paired", "2D"), type=c("none", "robust"), times, 
reps, prior.df=NULL, prior.COV=NULL, prior.eta=NULL,
condition.grp=NULL, rep.grp=NULL, time.grp=NULL, one.sample=FALSE, ref=NULL, p=0.02, out.t=FALSE, 
tuning=1.345, HotellingT2.only=TRUE)
{

   
     method <- match.arg(method, c("1D","paired","2D"))
     type <-  match.arg(type, c("none", "robust"))

     if(method=="1D" & type=="none")  out <- mb.1D(object, times, reps, prior.df, prior.COV, 
     prior.eta, time.grp, rep.grp, vec=out.t, prop=p, T2.only=HotellingT2.only)
     if(method=="1D" & type=="robust")  out <- mb.1D(object, times, reps, prior.df, 
     prior.COV, prior.eta, time.grp, rep.grp, r=TRUE, vec=out.t, d=tuning, prop=p, 
     T2.only=HotellingT2.only)
     if(method=="paired" & type=="none")  out <- mb.paired(object, times, reps, prior.df, 
     prior.COV, prior.eta,condition.grp, time.grp, rep.grp, one.sample, ref, vec=out.t, 
     prop=p,T2.only=HotellingT2.only)
     if(method=="paired" & type=="robust")  out <- mb.paired(object, times, reps, prior.df, 
     prior.COV, prior.eta, condition.grp, time.grp, rep.grp, one.sample, ref, r=TRUE, vec=out.t, 
     d=tuning, prop=p, T2.only=HotellingT2.only)
     if(method=="2D" & type=="none") out <- mb.2D(object, times, reps, prior.df, 
     prior.COV, prior.eta,condition.grp, time.grp, rep.grp, vec=out.t, prop=p, T2.only=HotellingT2.only)
     if(method=="2D" & type=="robust") out <- mb.2D(object, times, reps, prior.df, 
     prior.COV, prior.eta, condition.grp, time.grp, rep.grp, r=TRUE, vec=out.t, d=tuning, prop=p, 
     T2.only=HotellingT2.only)
     
     out
}

mb.MANOVA <- 
function (object, times, D, size, nu = NULL, Lambda = NULL, beta.d = NULL, 
    beta = NULL, alpha.d = NULL, alpha = NULL, condition.grp, 
    time.grp = NULL, rep.grp = NULL, p = 0.02) 
{
    res <- as.list(NULL)
    M <- NULL
    geneNames <- desc <- NULL
    if (is(object, "MAList") || is(object, "list")) 
        M <- object$M
    if (is(object, "marrayNorm")) {
        M <- object@maM
        geneNames <- rownames(M)
        desc <- object@maGnames@maLabels
    }
    if (is(object, "ExpressionSet")) {
        M <- exprs(object)
        geneNames <- rownames(M)
    }
    if (is.null(M)) 
        M <- as.matrix(object)
    tr <- function(X) {
        sum(diag(X))
    }
    G <- nrow(M)
    if (missing(times)) 
        stop("The number of time points is missing.")
    if (missing(size)) 
        stop("The sample sizes are missing.")
    if (missing(D)) 
        stop("The number of biological conditions is missing.")
    if (missing(condition.grp)) 
        stop("Biological condition assignments are missing.")
    if (length(unique(condition.grp)) != D) 
        stop("The biological condition group assignments are \n    incorrect!")
    if (!is.null(size)) {
        max.size <- apply(size, 2, max)
        if (ncol(size) != D) 
            stop("The sample sizes are incorrect!")
        for (i in 1:D) {
            if ((max.size[i] * times) != sum(condition.grp == 
                sort(unique(condition.grp))[i])) 
                stop("The sample sizes or the biological condition group assignments are incorrect!")
        }
    }
    if (is.null(time.grp)) {
        time.grp <- rep(1:times, ncol(M)/times)
        cat("Time group assignments are set to default.", "\n")
    }
    if (length(unique(time.grp)) != times) 
        stop("The number of time points or the time group \n    assignments is incorrect!")
    if (is.null(rep.grp)) {
        rep.grp <- rep(1:(ncol(M)/times), rep(times, ncol(M)/times))
        cat("Replicate group assignments are set to default.", 
            "\n")
    }
    mydata <- M
    indx <- order(condition.grp, rep.grp, time.grp)
    M <- M[, indx]
    mis <- apply(!apply(M, 1, is.na), 2, sum)
    mis <- sum((mis/times - floor(mis/times)) != 0)
    if (mis > 0) 
        stop(mis, " genes may have within replicate missing values.")
    N <- apply(size, 1, sum)
    Sp <- apply(M, 1, matrix.cov, times, trans = FALSE, c.grp = condition.grp)
    diagSp <- apply(Sp, 2, function(x) diag(matrix(x, ncol = times)))
    Sp.avg <- matrix(apply(Sp, 1, mean, na.rm = TRUE), ncol = times)
    if (is.null(nu) || is.null(Lambda)) {
        nu.lim <- times + 6
        if (!is.null(nu)) {
            nu0 <- nu
            nu <- max(nu0, nu.lim)
            if (is.infinite(nu) & is.null(Lambda)) {
                Lambda <- Sp.avg
            }
            if (is.finite(nu) & is.null(Lambda)) {
                Lambda <- (nu - times - 1) * Sp.avg/nu
            }
            nu <- nu0
        }
        if (is.null(nu)) {
            nu0 <- mean(sapply(1:times, function(x) squeezeVar(diagSp[x, 
                ], N - D)$df.prior))
            nu <- max(nu0, nu.lim)
            if (is.infinite(nu) & is.null(Lambda)) {
                Lambda <- Sp.avg
            }
            if (is.finite(nu) & is.null(Lambda)) {
                Lambda <- (nu - times - 1) * Sp.avg/nu
            }
            nu <- nu0
        }
    }
    max.size <- apply(size, 2, max)
    xbar.d <- as.list(NULL)
    for (i in 1:D) {
        grp.indx <- condition.grp == sort(unique(condition.grp))[i]
        xbar.d[[i]] <- apply(M[, grp.indx], 1, function(x) apply(matrix(x, 
            byrow = TRUE, ncol = times), 2, mean, na.rm = TRUE))
    }

    simple.stat <- NULL
    for(i in 1:(D-1))
       for(j in (i+1):D)
          simple.stat <- cbind(simple.stat, apply(abs(xbar.d[[i]]-xbar.d[[j]]),2,sum,na.rm=TRUE))
    
    simple.stat <- apply(simple.stat,1,sum,na.rm=TRUE)
    simple.rank <- G-rank(simple.stat)+1
    indx1 <- simple.rank<=G*p
    xbar <- sapply(1:G, function(x) apply(matrix(M[x, ], byrow = TRUE, 
        ncol = times), 2, mean, na.rm = TRUE))
    if (is.null(alpha.d)) 
        alpha.d <- sapply(1:D, function(x) apply(xbar.d[[x]][,indx1], 
            1, mean, na.rm = TRUE))
    if (is.null(alpha)) 
        alpha <- apply(xbar[,!indx1], 1, mean, na.rm = TRUE)

   
    if (is.null(beta.d) || is.null(beta)) {
        U.d <- lapply(1:D, function(x) apply(xbar.d[[x]][,indx1] - alpha.d[, 
            x], 2, function(y) y %*% t(y)))
        U <- apply(xbar[,!indx1] - alpha, 2, function(y) y %*% t(y))
        Ubar.d <- sapply(1:D, function(x) apply(U.d[[x]], 1, 
            mean, na.rm = TRUE))
        Ubar <- apply(U, 1, mean, na.rm = TRUE)
        if (is.null(beta.d)){
             Sp <- apply(M[indx1,], 1, matrix.cov, times, trans = FALSE, c.grp = condition.grp)
             Sp.avg <- matrix(apply(Sp, 1, mean, na.rm = TRUE), ncol = times) 
             beta.d <- sapply(1:D, function(x) tr(Sp.avg)/tr(matrix(Ubar.d[, 
                x], ncol = times)))
        }
        if (is.null(beta)){
            Sp <- apply(M[!indx1,], 1, matrix.cov, times, trans = FALSE, c.grp = condition.grp)
            Sp.avg <- matrix(apply(Sp, 1, mean, na.rm = TRUE), ncol = times) 
            beta <- tr(Sp.avg)/tr(matrix(Ubar, ncol = times))
        }
    }
    Sp <- apply(M, 1, matrix.cov, times, trans = FALSE, c.grp = condition.grp)
    Sp.avg <- matrix(apply(Sp, 1, mean, na.rm = TRUE), ncol = times) 
    U.d <- lapply(1:D, function(x) apply(xbar.d[[x]] - alpha.d[, 
            x], 2, function(y) y %*% t(y)))
    U <- apply(xbar- alpha, 2, function(y) y %*% t(y))
    total <- (N - 1) * apply(M, 1, matrix.cov, times, trans = FALSE, 
        c.grp = rep(1, ncol(M)))
    within <- Sp * (N - D)
    if (sum(N == max(N)) == G) 
        M <- U/(N[1]^(-1) + beta^(-1))
    if (sum(N == max(N)) < G) 
        M <- sapply(1:G, function(x) U[, x]/(N[x]^(-1) + beta^(-1)))
    M.d <- as.list(NULL)
    for (i in 1:D) {
        if (sum(size[, i] == max.size[i]) == G) 
            M.d[[i]] <- U.d[[i]]/(size[1, i]^(-1) + beta.d[i]^(-1))
        if (sum(size[, i] == max.size[i]) < G) 
            M.d[[i]] <- sapply(1:G, function(x) U.d[[i]][, x]/(size[x, 
                i]^(-1) + beta.d[i]^(-1)))
    }
    M1 <- matrix(0, nrow = times^2, ncol = G)
    for (i in 1:D) M1 <- M1 + M.d[[i]]
    tol <- .Machine$double.eps
    res$M <- mydata
    res$prop <- p
    res$nu <- nu
    res$Lambda <- Lambda
    res$alpha <- alpha
    res$alpha.d <- alpha.d
    res$beta <- beta
    res$beta.d <- beta.d
    if (nu < 0) 
        stop("The estimation of prior degrees of freedom <0 !")
    if (is.finite(nu) & nu > tol) {
        MB1 <- log(p, 10) - log(1 - p, 10)
        MB2 <- 0.5 * times * (log(N + beta, 10) - log(beta, 10))
        MB3 <- 0.5 * times * apply((log(beta.d, 10) - log(size + 
            beta.d, 10)), 1, sum)
        MB4 <- sapply(1:G, function(x) 0.5 * (N[x] + nu) * (log(det(matrix(total[, 
            x], ncol = times) + matrix(M[, x], ncol = times) + 
            nu * Lambda), 10) - log(det(matrix(within[, x], ncol = times) + 
            matrix(M1[, x], ncol = times) + nu * Lambda), 10)))
        MB <- MB1 + MB2 + MB3 + MB4
    }
    if (is.infinite(nu)) {
        MB1 <- log(p, 10) - log(1 - p, 10)
        MB2 <- 0.5 * times * (log(N + beta, 10) - log(beta, 10))
        MB3 <- 0.5 * times * apply((log(beta.d, 10) - log(size + 
            beta.d, 10)), 1, sum)
        MB4 <- sapply(1:G, function(x) tr(matrix(total[, x], 
            ncol = times) - matrix(within[, x], ncol = times) + 
            matrix(M[, x], ncol = times) - matrix(M1[, x], ncol = times)) - 
            log(10))
        MB <- MB1 + MB2 + MB3 + MB4
    }
    if (nu < tol & nu >= 0) {
        MB1 <- log(p, 10) - log(1 - p, 10)
        MB2 <- 0.5 * times * (log(N + beta, 10) - log(beta, 10))
        MB3 <- 0.5 * times * apply((log(beta.d, 10) - log(size + 
            beta.d, 10)), 1, sum)
        MB4 <- sapply(1:G, function(x) 0.5 * N[x] * (log(det(matrix(total[, 
            x], ncol = times) + matrix(M[, x], ncol = times)), 
            10) - log(det(matrix(within[, x], ncol = times) + 
            matrix(M1[, x], ncol = times)), 10)))
        MB <- MB1 + MB2 + MB3 + MB4
    }
    res$size <- size
    res$con.group <- condition.grp
    res$rep.group <- rep.grp
    res$time.group <- time.grp
    res$MB <- MB
    res$pos.MB <- order(MB, decreasing = TRUE)
    res$geneNames <- geneNames
    res$descriptions <- desc
    new("MArrayTC", res)
}

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004
## Last Modified: August 16, 2005


mb.2D <- function(object, k, mn, nu=NULL, Lambda=NULL, eta=NULL, c.grp, k.grp=NULL, 
mn.grp=NULL, r=FALSE, vec=FALSE, d=NULL, prop=0.02, T2.only=TRUE)
{

    res <- as.list(NULL)
    M <- NULL
    geneNames <- desc <- NULL
    if (is(object, "MAList") || is(object, "list")) 
          M <- object$M

    if (is(object, "marrayNorm"))
    {
          M <- object@maM
          geneNames <- rownames(M)
          desc <- object@maGnames@maLabels
    }

    if (is(object, "ExpressionSet"))
    {
          M <- exprs(object)
          geneNames <- rownames(M)               
    }

            
    if (is.null(M)) 
        M <- as.matrix(object)


    G <- nrow(M)
    if(missing(k)) stop("The number of time points is missing.")
    if(missing(mn)) stop("The sample sizes are missing.")
    if(missing(c.grp)) stop("Biological condition assignments are missing.")
    if(length(unique(c.grp)) != 2) stop("The biological condition group assignments are incorrect!")
    
     if(!is.null(mn))
     {
          max.mn1 <- max(mn[,1])
          max.mn2 <- max(mn[,2])
          if(ncol(mn) != length(unique(c.grp))) stop("The sample sizes are incorrect!")
          if(((max.mn1*k) != sum(c.grp==sort(unique(c.grp))[1])) || ((max.mn2*k) != sum(c.grp==sort(unique(c.grp))[2])))
                   stop("The sample sizes or the biological condition group assignments are incorrect!")
     }

    if(is.null(k.grp))
    { 
        k.grp <- rep(1:k, ncol(M)/k)
        cat("Time group assignments are set to default.","\n")
    }
    if(length(unique(k.grp)) != k) stop("The number of time points or the time group assignments are 
    incorrect")
    if(is.null(mn.grp))
    { 
        mn.grp <- rep(1:(ncol(M)/k), rep(k, ncol(M)/k))
        cat("Replicate group assignments are set to default.","\n")
    }
   
   
   mydata <- M
   indx <- order(c.grp, mn.grp, k.grp)
   M <- M[,indx]
  
   mis <- apply(!apply(M, 1, is.na), 2, sum)
   mis <- sum((mis/k-floor(mis/k)) !=0)
   if(mis>0) stop(mis, " genes may have within replicate missing values.")


   N <- apply(mn,1,sum)
 
          ## sample sizes across genes are the same
          ## only need to input the common sample size
          Sp <- apply(M, 1, matrix.cov, k, trans=FALSE, c.grp=c.grp)
          diagSp <- apply(Sp, 2, function(x) diag(matrix(x,ncol=k)))
          Sp.avg <- matrix(apply(Sp, 1, mean, na.rm=TRUE),ncol=k)
      
   

  if(is.null(nu)||is.null(Lambda))
  {
  
   nu.lim <- k+6
   
   if(!is.null(nu)) 
   {
     nu0 <- nu
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu)& is.null(Lambda))  {Lambda <- Sp.avg} 
     if(is.finite(nu)& is.null(Lambda))    {Lambda <- (nu-k-1)*Sp.avg/nu}
     nu<- nu0
   }

   if(is.null(nu))
   {
     nu0 <- mean(sapply(1:k, function(x) squeezeVar(diagSp[x,], N-2)$df.prior))
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu)& is.null(Lambda))  {Lambda <- Sp.avg} 
     if(is.finite(nu)& is.null(Lambda))    {Lambda <- (nu-k-1)*Sp.avg/nu}
     nu<- nu0
   }
  }
   
   max.n1 <- max(mn[,1])
   max.n2 <- max(mn[,2])
   xbar1 <- apply(M[, 1:(k*max.n1)], 1, function(x) 
   apply(matrix(x,  byrow=FALSE, ncol=max.n1),1,mean,na.rm=TRUE))
   xbar2 <- apply(M[, -c(1:(k*max.n1))], 1, function(x) 
   apply(matrix(x,  byrow=FALSE, ncol=max.n2),1,mean,na.rm=TRUE))
   if(r)
   {
        e1 <- sapply(1:G, function(x) matrix(M[x, 1:(k*max.n1)], byrow=FALSE, ncol=max.n1)-xbar1[,x])
        tune1 <- sapply(1:G, function(x) d * median(abs(e1[, x]),na.rm = TRUE)/0.6745)
        indx1 <- sapply(1:G, function(x) abs(e1[, x]) > tune1[x])
        na.indx1 <- sapply(1:G, function(x) c(1:(k * max.n1))[!is.na(indx1[,x])])
        wt1 <- matrix(rep(1, G * max.n1 * k), ncol = max.n1 * k)
        wt1 <- t(sapply(1:G, function(x) {wt1[x,][-na.indx1[,x]] <- 0
              wt1[x,]}))
        wt1 <- t(sapply(1:G, function(x) {wt1[x, ][na.indx1[,x]][indx1[,x][na.indx1[,x]]] <-
        tune1[x]/abs(e1[,x][na.indx1[,x]][indx1[,x][na.indx1[,x]]])
        wt1[x,]}))
        totalw1 <- sapply(1:G, function(x) apply(matrix(wt1[x,], byrow=FALSE, ncol=max.n1), 1, sum,
        na.rm=TRUE))
        w1 <- sapply(1:G, function(x) matrix(wt1[x,], byrow=FALSE, ncol=max.n1)/totalw1[,x])
        xbar1 <- sapply(1:G, function(x)
        apply(matrix(w1[, x] * M[x, 1:(k*max.n1)], byrow = FALSE, ncol = max.n1),1, sum,na.rm=TRUE))


        e2 <- sapply(1:G, function(x) matrix(M[x, -(1:(k*max.n1))], byrow=FALSE, ncol=max.n2)-xbar2[,x])
        tune2 <- sapply(1:G, function(x) d * median(abs(e2[, x]),na.rm = TRUE)/0.6745)
        indx2 <- sapply(1:G, function(x) abs(e2[, x]) > tune2[x])
        na.indx2 <- sapply(1:G, function(x) c(1:(k * max.n2))[!is.na(indx2[,x])])
        wt2 <- matrix(rep(1, G * max.n2 * k), ncol = max.n2 * k)
        wt2 <- t(sapply(1:G, function(x) {wt2[x,][-na.indx2[,x]] <- 0
              wt2[x,]}))
        wt2 <- t(sapply(1:G, function(x) {wt2[x, ][na.indx2[,x]][indx2[,x][na.indx2[,x]]] <-
        tune2[x]/abs(e2[,x][na.indx2[,x]][indx2[,x][na.indx2[,x]]])
        wt2[x,]})) 
        totalw2 <- sapply(1:G, function(x) apply(matrix(wt2[x,], byrow=FALSE, ncol=max.n2), 1, sum,
        na.rm=TRUE))
        w2 <- sapply(1:G, function(x) matrix(wt2[x,], byrow=FALSE, ncol=max.n2)/totalw2[,x])
        xbar2 <- sapply(1:G, function(x)
        apply(matrix(w2[, x] * M[x, -(1:(k*max.n1))], byrow = FALSE, ncol = max.n2),1, sum,na.rm=TRUE))
        wt <- cbind(wt1, wt2)
    }



   X <- xbar1-xbar2
   tol <- .Machine$double.eps
   if(is.finite(nu) & nu > tol) 
   {
     modSp <- sapply(1:G, function(x) ((N[x]-2)*matrix(Sp[,x],ncol=k)+nu*Lambda)/(N[x]-2+nu))
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modSp <- apply(modSp, 2, function(x)
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v))
     modt <- sapply(1:G, function(x) 
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1/2)*solve(matrix(sqrt.modSp[,x],ncol=k))%*%X[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1)*t(X[,x])%*%solve(matrix(modSp[,x],ncol=k))%*%X[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
   }

   if(is.infinite(nu))
   {
     modSp <- sapply(1:G, function(x) Lambda)
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modSp <- apply(modSp, 2, function(x)
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v))
     modt <- sapply(1:G, function(x)
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1/2)*solve(matrix(sqrt.modSp[,x],ncol=k))%*%X[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1)*t(X[,x])%*%solve(matrix(modSp[,x],ncol=k))%*%X[,x]) 

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
   }
   if(nu < tol & nu >=0)
   {
     modSp <- Sp
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modSp <- apply(modSp, 2, function(x)
     svd(matrix(x,ncol=k))$u%*%diag(sqrt(svd(matrix(x,ncol=k))$d))%*%t(svd(matrix(x,ncol=k))$v))
     modt <- sapply(1:G, function(x)
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1/2)*ginv(matrix(sqrt.modSp[,x],ncol=k))%*%X[,x])
     HotellingT2 <- apply(modt, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
     (mn[x,1]^(-1)+mn[x,2]^(-1))^(-1)*t(X[,x])%*%ginv(matrix(modSp[,x],ncol=k))%*%X[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
   }
   if(is.null(eta)& (T2.only==FALSE)) eta <- mean(sapply(1:k, function(x) tmixture.matrix(modt[x,], 
   sqrt(mn[,1]^(-1)+mn[,2]^(-1)), N+nu-2, prop, c(0.1, 4)^2/Lambda[x,x]))^(-1))

   res$M <- mydata
   res$prop <- prop
   res$nu <- nu
   res$Lambda <- Lambda
   res$eta <- eta

 
  if(nu < 0) stop("The estimation of prior degrees of freedom <0 !")
   
  MB <- NULL
  if(T2.only==FALSE)
  {
  if(is.finite(nu) & nu > tol)
  {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- 0.5*k*(log(mn[,1]^(-1)+mn[,2]^(-1),10)-log(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1),10))
      MB3 <-0.5*(N+nu-1)*(log(N-2+nu+HotellingT2,10)-log(N-2+nu+((mn[,1]^(-1)+mn[,2]^(-1))/(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1)))*HotellingT2,10))
      MB <- MB1+MB2+MB3
   }
   if (is.infinite(nu))
   {
       MB1 <- log(prop,10)-log(1-prop,10)
       MB2 <- 0.5*k*(log(mn[,1]^(-1)+mn[,2]^(-1),10)-log(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1),10))
       MB3 <- 0.5*(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1))*HotellingT2/(mn[,1]^(-1)+mn[,2]^(-1))
       MB <- MB1+MB2+MB3
   }
   if (nu < tol & nu >= 0)
   {
       MB1 <- log(prop,10)-log(1-prop,10)
       MB2 <- 0.5*k*(log(mn[,1]^(-1)+mn[,2]^(-1),10)-log(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1),10))
       MB3 <- 0.5*(N-1)*(log(N-2+HotellingT2,10)-log(N-2+((mn[,1]^(-1)+mn[,2]^(-1))/(mn[,1]^(-1)+mn[,2]^(-1)+eta^(-1)))*HotellingT2,10))
       MB <- MB1+MB2+MB3
   }
   }
      unique.N <- unique(N)
      if(is.finite(nu) && nu > tol) 
           res$percent <- matrix(c(unique.N, round(100*nu/(nu+unique.N-2))), ncol=2)

      if(is.infinite(nu)) res$percent <- matrix(c(unique.N, 100), ncol=2)
      if(nu < tol && nu >=0) res$percent <- matrix(c(unique.N, 0), ncol=2)
      res$size <- mn
      res$con.group <- c.grp
      res$rep.group <- mn.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt <- modt
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
      
   res$pos.HotellingT2 <- order(HotellingT2, decreasing = TRUE)
   if(!is.null(MB)) res$pos.MB <- order(MB, decreasing = TRUE)
   res$geneNames <- geneNames
   res$descriptions <- desc
   new("MArrayTC", res)


}

univ.func <-
function (dummy, M, k, n, indx = 1) 
{
    #if (!is.numeric(M[dummy,])) 
        x <- as.numeric(M[dummy,])
    if (missing(n)) 
        n <- apply(M, 1, function(x) sum(apply((!apply(matrix(x, byrow=TRUE, ncol=k),1, 
        is.na)),2,sum)>=1))

    x <- matrix(x, byrow = FALSE, ncol = max(n))
    OT <- ot.helmert(k)
    res <- OT[indx, ] %*% x
    res
}

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004
## Last Modified: July 4, 2005

matrix.cov <- function(x, k, trans=TRUE, c.grp=NULL, use="complete.obs")
{
   # x is already sorted by c.grp, n.grp and k.grp
   if(!is.numeric(x))  x <- as.numeric(x)
   if(missing(k)) stop("The number of time points is missing.")
   #if(k <2 & length(unique(c.grp))==1) stop("Input at least two time points.")

   #if(is.null(size)) size <- length(x)/k
   
   if(length(unique(c.grp))==1)
   {
      res <-cov(matrix(x, byrow=TRUE, ncol=k),use=use)

     if(trans)
     {
        OT1 <- ot.helmert(k)[2:k,]
        if(k==2) OT1 <- t(as.matrix(OT1))
        res <- OT1%*%res%*%t(OT1)
      }

   }

   if(length(unique(c.grp))>1 & !trans)
   {
      D <- length(unique(c.grp))
      size <- max.size <- NULL
      for(i in 1:D)
      {
         grp.indx <- c.grp==sort(unique(c.grp))[i]
         if(k==1) size[i] <- sum(apply(t(as.matrix(!apply(matrix(x[grp.indx], byrow=TRUE,ncol=k),1, is.na))),2,sum)==k)
         if(k>1) size[i] <- sum(apply((!apply(matrix(x[grp.indx], byrow=TRUE,ncol=k),1, is.na)),2,sum)==k)
         max.size[i] <- sum(grp.indx)/k
      }
      cumsize <- cumsum(max.size)
      cumsize1 <- cumsum(size)
      res1 <- as.list(NULL)
      for(i in 1:D)
      {
        if(size[i]==1) res1[[i]] <- matrix(0,k,k)
        if(i==1 & size[i]>1) res1[[i]] <- cov(matrix(x[1:(k*cumsize[1])], byrow=TRUE, ncol=k),use=use)
        if(i>1& size[i]>1) res1[[i]] <- cov(matrix(x[(k*cumsize[i-1]+1):(k*cumsize[i])], byrow=TRUE, ncol=k),use=use)
      }
      
      if(k>1) res <- matrix(apply(sapply(1:D, function(x) (size[x]-1)*res1[[x]]),1,sum),ncol=k)/(cumsize1[D]-D)
      if(k==1) res <- matrix(sum(sapply(1:D, function(x) (size[x]-1)*res1[[x]])),ncol=k)/(cumsize1[D]-D)
   }

   res

}

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Plots the temporal profile for a single gene
## Created: August, 2004
## Last Modified: July 23, 2005

plotProfile <- 
function (object, stats = c("HotellingT2", "MB"), ranking = 1, 
    gid = NULL, gnames = NULL, desc = NULL, type = c("p", "l", 
        "b"), col = 2:100, lty = 1:100, pch = 1:100, 
    lwd = 2, xlab = "Time", ylab = "Expression", legloc = NULL, 
    xlim = NULL, ylim = NULL, cex.main = 1, ...) 
{
    if (!is.null(object$geneNames)) 
        gnames <- object$geneNames
    if (!is.null(object$descriptions)) 
        desc <- object$descriptions
    indx <- order(object$con.group, object$rep.group, object$time.group)
    M <- object$M[, indx]
    G <- nrow(M)
    if (!is.character(desc)) 
        desc <- as.character(desc)
    stats <- match.arg(stats, c("HotellingT2", "MB"))
    type <- match.arg(type, c("p", "l", "b"))
    if (!is.null(gid)) 
        ranking <- NULL
    if (stats == "HotellingT2" & !is.null(ranking)) {
        pos <- object$pos.HotellingT2[ranking]
        val <- object$HotellingT2[pos]
        gid <- gnames[pos]
    }
    if (stats == "MB" & !is.null(ranking)) {
        pos <- object$pos.MB[ranking]
        val <- object$MB[pos]
        gid <- gnames[pos]
    }
    if (stats == "HotellingT2" & is.null(ranking)) {
        pos <- c(1:G)[gnames == gid]
        if (length(pos) > 1) 
        {
            pos <- pos[1]
            warning(length(pos), " genes have the same gene ID...only the first gene is plotted!") 
        }
        val <- object$HotellingT2[pos]
        ranking <- G - rank(object$HotellingT2)[pos] + 1
    }
    if (stats == "MB" & is.null(ranking)) {
        pos <- c(1:G)[gnames == gid]
        if (length(pos) > 1) 
        {
            pos <- pos[1]
            warning(length(pos), " genes have the same gene ID...only the first gene is plotted!") 
        }
        val <- object$MB[pos]
        ranking <- G - rank(object$MB)[pos] + 1
    }
    x <- M[pos, ]
    desc <- desc[pos]
    size <- as.matrix(object$size)[pos, ]
    D <- length(size)
    k <- length(unique(object$time.group))
    y <- matrix(x, byrow = TRUE, ncol = k)
    yulim <- max(y, na.rm = TRUE) + 0.4 * (max(y, na.rm = TRUE) - 
        min(y, na.rm = TRUE))
    yllim <- min(y, na.rm = TRUE) - 0.4 * (max(y, na.rm = TRUE) - 
        min(y, na.rm = TRUE))
    xulim <- max(unique(object$time.group), na.rm = TRUE) + 1
    xllim <- min(unique(object$time.group), na.rm = TRUE) - 1
    if (is.null(ylim)) 
        ylim <- c(yllim, yulim)
    if (is.null(xlim)) 
        xlim <- c(xllim, xulim)
    if (!is.null(desc)) {
        plot(sort(unique(object$time.group)), y[1, ], type = "n", 
            main = paste(gid, "", stats, "=", round(val, 1), 
                "", "rank=", ranking), xlim = xlim, ylim = ylim, 
            xlab = xlab, ylab = ylab, cex.main = cex.main)
        mtext(substr(desc, 1, 10), 4)
    }
    if (is.null(desc)) 
        plot(sort(unique(object$time.group)), y[1, ], type = "n", 
            main = paste(gid, "", stats, "=", round(val, 1), 
                "", "rank=", ranking), xlim = xlim, ylim = ylim, 
            xlab = xlab, ylab = ylab, cex.main = cex.main)
    rep.pch <- rep.lty <- con <- matrix(rep(0, max(as.matrix(object$size)) * 
    ncol(as.matrix(object$size))), ncol = ncol(as.matrix(object$size)))
    
    con2 <- NULL
    if (D !=2) {
        rep.indx <- unique(cbind(object$con.group, object$rep.group))
        #tmp <- (rep.indx[, 1] == sort(unique(object$con.group))[1])
        tmp <- sapply(1:D, function(z) rep.indx[,1]==sort(unique(object$con.group))[z])
        for(z in 1:D)
        {
           con <- con1 <- sort(rep.indx[tmp[,z], 2])
           con2[z] <- length(con)
           if(z==1)
           {
              rep.pch[1:con2[z], z] <- pch[1:cumsum(con2)[z]]
              rep.lty[1:con2[z], z] <- lty[1:cumsum(con2)[z]]

           }
           if(z >1 )
           {
               rep.pch[1:con2[z], z] <- pch[(cumsum(con2)[z-1]+1):cumsum(con2)[z]]
               rep.lty[1:con2[z], z] <- lty[(cumsum(con2)[z-1]+1):cumsum(con2)[z]]
            }
        }
    }

    if (D == 2) {
        rep.indx <- unique(cbind(object$con.group, object$rep.group))
        tmp <- (rep.indx[, 1] == sort(unique(object$con.group))[1])
        con1 <- sort(rep.indx[tmp, 2])
        tmp <- (rep.indx[, 1] == sort(unique(object$con.group))[2])
        con2 <- sort(rep.indx[tmp, 2])
        if (length(con1) < length(con2)) 
            con1[(length(con1) + 1):length(con2)] <- NA
        if (length(con2) < length(con1)) 
            con2[(length(con2) + 1):length(con1)] <- NA
        con <- data.frame(con1, con2)
        rep.pch[1:nrow(con[!is.na(con[, 1]), ]), 1] <- pch[1:nrow(con[!is.na(con[, 
            1]), ])]
        rep.lty[1:nrow(con[!is.na(con[, 1]), ]), 1] <- lty[1:nrow(con[!is.na(con[, 
            1]), ])]
        both <- intersect(con[, 1], con[, 2])
        if (length(both) > 0) {
            for (i in 1:length(both)) {
                for (j in 1:nrow(con)) {
                  if (con[j, 2] == both[i] & !is.na(con[j, 2])) 
                    rep.pch[j, 2] <- rep.pch[con[, 1]  == both[i],1]  
                  if (con[j, 2] == both[i] & !is.na(con[j, 2]))
                    rep.lty[j, 2] <- rep.lty[con[, 1]  == both[i],1]
                 
                }
            }
        }
        for (j in 1:nrow(con)) {
            if (rep.pch[j, 2] == 0) 
                rep.pch[j, 2] <- pch[nrow(con[!is.na(con[, 1]), 
                  ]) + j]
            if (rep.lty[j, 2] == 0) 
                rep.lty[j, 2] <- lty[nrow(con[!is.na(con[, 1]), 
                  ]) + j]
        }
    }
    tmp <- NULL
    con.indx <- cumsum(apply(as.matrix(object$size),2,max))
    for (j in 1:D) {
        if (j == 1) 
            mydata <- y[1:con.indx[j], ]
        if (j > 1) 
            mydata <- y[(con.indx[j - 1] + 1):con.indx[j], ]
        #if (is.null(object$weights)) 
        #    mean.vec <- apply(mydata, 2, mean, na.rm = TRUE)
        #if (!is.null(object$weights)) {
        #    w1 <- matrix(object$weights[pos, 1:(k * size[j])], 
        #        byrow = FALSE, ncol = size[j])
        #    totalw1 <- apply(w1, 1, sum)
        #    object$weights[pos, 1:(k * size[j])] <- as.numeric(w1/totalw1)
        #    mean.vec <- apply(matrix(object$weights[pos, 1:(k * 
        #        size[j])] * as.numeric(t(mydata)), byrow = FALSE, 
        #        ncol = size[j]), 1, sum, na.rm = TRUE)
        #}
        for (i in 1:nrow(mydata)) {
            if (length(size) == 1) {
                lines(sort(unique(object$time.group)), mydata[i, 
                  ], type = type, col = col[i], lty = rep.lty[i, 
                  j], pch = rep.pch[i, j], lwd = lwd)
                tmp <- cbind(tmp, sort(unique(object$time.group)), 
                  mydata[i, ])
            }
            if (D > 1) {
                lines(sort(unique(object$time.group)), mydata[i, 
                  ], type = type, col = col[j], lty = rep.lty[i, 
                  j], pch = rep.pch[i, j], lwd = lwd)
                tmp <- cbind(tmp, sort(unique(object$time.group)), 
                  mydata[i, ])
            }
        }
        #if (avg) {
        #    if (length(size) == 1) 
        #        lines(sort(unique(object$time.group)), mean.vec, 
        #          type = "l", lwd = lwd, col = 1)
        #    if (D > 1) 
        #        lines(sort(unique(object$time.group)), mean.vec, 
        #          type = "l", lwd = lwd, col = col[j])
        #}
    }
    corner <- matrix(c(xlim[1], ylim[1], xlim[1], ylim[2], xlim[2], 
        ylim[1], xlim[2], ylim[2]), byrow = TRUE, ncol = 2)
    tmp <- matrix(as.numeric(t(tmp)), byrow = TRUE, ncol = 2)
    loc <- NULL
    for (m in 1:nrow(corner)) {
        tt <- rbind(corner[m, ], tmp)
        corner.dist <- dist(tt)
        loc[m] <- min(as.matrix(corner.dist)[-1, 1])
    }
    if (is.null(legloc)) {
        legloc <- corner[order(loc, decreasing = TRUE)[1], ]
        if (order(loc, decreasing = TRUE)[1] == 1) 
            legloc[2] <- legloc[2] + loc[1]
        if (order(loc, decreasing = TRUE)[1] == 2) 
            legloc[2] <- legloc[2] - loc[2]
        if (order(loc, decreasing = TRUE)[1] == 3) {
            legloc[1] <- legloc[1] - loc[3]
            legloc[2] <- legloc[2] + loc[3]
        }
        if (order(loc, decreasing = TRUE)[1] == 4) 
            legloc[1] <- legloc[1] - loc[4]
    }
    if (type == "b") {
        rep.pch <- as.vector(rep.pch)[as.vector(rep.pch) > 
            0]
        rep.lty <- as.vector(rep.lty)[as.vector(rep.lty) > 
            0]
         
        if (D == 1) {
            na.indx <- apply(y,1,is.na)[1,]
            rep.lty <- rep.lty[1:max(object$size)][!na.indx]
            rep.pch <- rep.pch[1:max(object$size)][!na.indx]
            col <- col[1:max(object$size)][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], lty = rep.lty, lwd = lwd, 
                col = col, pch = rep.pch, text.col = col, 
                cex = 0.75)
        }
        if (D > 1) {
            na.indx <- apply(y,1,is.na)[1,]
            tmp <- sum(apply(object$size,2,max))
            rep.lty <- rep.lty[1:tmp][!na.indx]
            rep.pch <- rep.pch[1:tmp][!na.indx]
            col <- col[rep(1:length(unique(object$con.group)), apply(object$size,2,max))][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], lty = rep.lty, lwd = lwd, 
                col = col, pch = rep.pch, text.col = col, cex = 0.75)
        }
    }
    if (type == "p") {
        rep.pch <- as.vector(rep.pch)[as.vector(rep.pch) > 
            0]
        rep.lty <- as.vector(rep.lty)[as.vector(rep.lty) > 
            0]
        if (D == 1){
            na.indx <- apply(y,1,is.na)[1,]
            rep.pch <- rep.pch[1:max(object$size)][!na.indx]
            col <- col[1:max(object$size)][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], col = col, pch = rep.pch, 
                text.col = col, cex = 0.75)
        }
        if (D > 1){
            na.indx <- apply(y,1,is.na)[1,]
            tmp <- sum(apply(object$size,2,max))
            rep.pch <- rep.pch[1:tmp][!na.indx]
            col <- col[rep(1:length(unique(object$con.group)), apply(object$size,2,max))][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], col = col, pch = rep.pch, 
                text.col = col, cex = 0.75)
        }
    }
    if (type == "l") {
        rep.pch <- as.vector(rep.pch)[as.vector(rep.pch) > 
            0]
        rep.lty <- as.vector(rep.lty)[as.vector(rep.lty) > 
            0]
        if (D == 1) {
            na.indx <- apply(y,1,is.na)[1,]
            rep.lty <- rep.lty[1:max(object$size)][!na.indx]
            col <- col[1:max(object$size)][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], lty = rep.lty, lwd = lwd, 
                col = col, text.col = col, cex = 0.75)
        }
        if (D > 1) {
            na.indx <- apply(y,1,is.na)[1,]
            tmp <- sum(apply(object$size,2,max))
            rep.lty <- rep.lty[1:tmp][!na.indx]
            col <- col[rep(1:length(unique(object$con.group)), apply(object$size,2,max))][!na.indx]
            legend(legloc[1], legloc[2], legend = sort(unique(paste(object$con.group, 
                object$rep.group)))[!na.indx], lty = rep.lty, lwd = lwd, 
                col = col, text.col = col, cex = 0.75)
        }
    }
}

abs2ratio <- function(x, mn, k, c.grp, reference)
{
    # x is already sorted by c.grp, n.grp and k.grp
    max.1 <- max(mn[,1])
    max.2 <- max(mn[,2])
    N <- max.1+max.2
    x1 <- x[1:(max.1*k)]
    x2 <- x[(max.1*k+1):(N*k)]
    if(reference>sort(unique(c.grp))[1])  res <- x1-x2

    if(reference==sort(unique(c.grp))[1]) res <- x2-x1

    res
}
     

#abs2ratio <-function (dummy, M, mn, k, c.grp, reference) 
#{
#    N <- max(mn[,1])+max(mn[,2])
#    x1 <- M[dummy, 1:(max(mn[,1]) * k)]
#    x2 <- M[dummy, (max(mn[,1]) * k + 1):(N * k)]
#    if (reference > sort(unique(c.grp))[1]) 
#        res <- x1 - x2
#    if (reference == sort(unique(c.grp))[1]) 
#        res <- x2 - x1
#    res
#}

## (c) 2004-2005 Yu Chuan Tai
## University of California, Berkeley
## Created: August 2004     
## Last Modified: July 16, 2005

mb.1D <- function(object, k, n, nu=NULL, Lambda1=NULL, eta=NULL, k.grp=NULL, n.grp=NULL, 
r=FALSE, vec=FALSE, d=NULL, prop=0.01, T2.only=TRUE)
{

    res <- as.list(NULL)
    M <- NULL
    geneNames <- desc <- NULL
    if (is(object, "MAList") || is(object, "list")) 
          M <- object$M
   
    if (is(object, "marrayNorm"))
    {
          M <- object@maM
          geneNames <- rownames(M)
          desc <- object@maGnames@maLabels
    }
            
    if (is(object, "ExpressionSet")) 
    {
          M <- exprs(object)
          geneNames <- rownames(M)
    }
            
    if (is.null(M)) 
        M <- as.matrix(object)

   G <- nrow(M)
   if(missing(k)) stop("The number of time points is missing.")
   if(missing(n)) stop("The sample sizes are missing.")
   max.n <- max(n)
   if(!is.null(n) & length(n) !=G) stop("The sample sizes are incorrect.")
     
   if(is.null(k.grp)) 
   {
         k.grp <- rep(1:k, max.n)
         cat("Time group assignments are set to default.","\n")
   }
   if(length(unique(k.grp)) != k) 
      stop("The number of time points or the time group assignments is incorrect.")
      
   if(is.null(n.grp)) 
   {
        n.grp <- rep(c(1:max.n), rep(k, max.n))
        cat("Replicate group assignments are set to default.", "\n")
   }
   
   
   mydata <- M
   indx <- order(n.grp, k.grp)
   M <- M[,indx]
  
   mis <- apply(!apply(M, 1, is.na), 2, sum)
   mis <- sum((mis/k-floor(mis/k)) !=0)
   if(mis>0) stop(mis, " genes may have missing values in some of the replicates.")

 
   if((max.n*k) !=ncol(M)) stop("The number of time points or sample sizes are incorrect.")
   if(length(unique(n.grp)) != max.n) stop("Sample sizes or replicate group assignments is incorrect.")   
   c.grp <- rep(1, k*max.n)
   
       S1 <- apply(M, 1, matrix.cov, k, c.grp=c.grp)
       if(is.null(nu)) diagS1 <- apply(S1, 2, function(x) diag(matrix(x,ncol=k-1)))
       S1.avg <- matrix(apply(S1, 1, mean, na.rm=TRUE),ncol=k-1)
     
   

   if(is.null(nu)||is.null(Lambda1))
   {
     nu.lim <- k-1+6
   

    if(!is.null(nu))
    {
     nu0 <- nu
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu) & is.null(Lambda1))  {Lambda1 <- S1.avg} 
     if(is.finite(nu)& is.null(Lambda1))    {Lambda1 <- (nu-k)*S1.avg/nu }
     nu<- nu0
   }

   if(is.null(nu))
   {
     nu0 <- mean(sapply(1:(k-1), function(x) squeezeVar(diagS1[x,], n-1)$df.prior))
     nu <- max(nu0, nu.lim)
     if(is.infinite(nu)& is.null(Lambda1))  {Lambda1 <- S1.avg} 
     if(is.finite(nu)& is.null(Lambda1))    {Lambda1 <- (nu-k)*S1.avg/nu }
     nu<- nu0
   }
   }
   
   max.n <- max(n)
   T1 <- ot.helmert(k)[2:k,]
   xbar <- apply(M, 1, function(x) apply(matrix(x,  byrow=FALSE, ncol=max.n),1,mean,na.rm=TRUE))

   if(r)
   {    
        e <- sapply(1:G, function(x) matrix(M[x,], byrow=FALSE, ncol=max.n)-xbar[,x])
        tune <- sapply(1:G, function(x) d * median(abs(e[, x]),na.rm = TRUE)/0.6745)
        indx <- sapply(1:G, function(x) abs(e[, x]) > tune[x])
        na.indx <- sapply(1:G, function(x) c(1:(k * max.n))[!is.na(indx[,x])])
        wt <- matrix(rep(1, G * max.n * k), ncol = max.n * k)
        wt <- t(sapply(1:G, function(x) {wt[x,][-na.indx[,x]] <- 0 
              wt[x,]}))        
        wt <- t(sapply(1:G, function(x) {wt[x, ][na.indx[,x]][indx[,x][na.indx[,x]]] <- 
        tune[x]/abs(e[,x][na.indx[,x]][indx[,x][na.indx[,x]]])
        wt[x,]}))
        totalw <- sapply(1:G, function(x) apply(matrix(wt[x,], byrow=FALSE, ncol=max.n), 1, sum, 
        na.rm=TRUE))
        w <- sapply(1:G, function(x) matrix(wt[x,], byrow=FALSE, ncol=max.n)/totalw[,x])
        xbar <- sapply(1:G, function(x) 
        apply(matrix(w[, x] * M[x, ], byrow = FALSE, ncol = max.n),1, sum,na.rm=TRUE))

       
            
    }

   tol <- .Machine$double.eps
   if(is.finite(nu) & nu > tol) 
   {
     modS1 <- sapply(1:G, function(x) ((n[x]-1)*matrix(S1[,x],ncol=k-1)+nu*Lambda1)/(n[x]-1+nu))
     if(is.null(eta) & (T2.only==FALSE))
     {
       sqrt.modS1 <- apply(modS1, 2, function(x)
       svd(matrix(x,ncol=k-1))$u%*%diag(sqrt(svd(matrix(x,ncol=k-1))$d))%*%t(svd(matrix(x,ncol=k-1))$v))
       modt1 <- sapply(1:G, function(x) n[x]^(1/2)*solve(matrix(sqrt.modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
       HotellingT2 <- apply(modt1, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
         HotellingT2 <- sapply(1:G, function(x) 
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])

      if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])

   }

   if(is.infinite(nu))
   {
     modS1 <- sapply(1:G, function(x) Lambda1)
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modS1 <- apply(modS1, 2, function(x)
     svd(matrix(x,ncol=k-1))$u%*%diag(sqrt(svd(matrix(x,ncol=k-1))$d))%*%t(svd(matrix(x,ncol=k-1))$v))
     modt1 <- sapply(1:G, function(x) n[x]^(1/2)*solve(matrix(sqrt.modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
     HotellingT2 <- apply(modt1, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
         n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
   }
   if(nu < tol & nu >=0)
   {
     modS1 <- S1
     if(is.null(eta) & (T2.only==FALSE))
     {
     sqrt.modS1 <- apply(modS1, 2, function(x)
     svd(matrix(x,ncol=k-1))$u%*%diag(sqrt(svd(matrix(x,ncol=k-1))$d))%*%t(svd(matrix(x,ncol=k-1))$v))
     modt1 <- sapply(1:G, function(x) n[x]^(1/2)*ginv(matrix(sqrt.modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
     HotellingT2 <- apply(modt1, 2, function(x) t(x)%*%x)
     }
     if(T2.only)
     HotellingT2 <- sapply(1:G, function(x)
     n[x]*t(T1%*%xbar[,x])%*%ginv(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])

     if(!is.null(eta) & (T2.only==FALSE))
         HotellingT2 <- sapply(1:G, function(x)
                n[x]*t(T1%*%xbar[,x])%*%solve(matrix(modS1[,x],ncol=k-1))%*%T1%*%xbar[,x])
   }

     
   # HotellingT2 does not require eta
   if(is.null(eta) & (T2.only==FALSE)) eta <- mean(sapply(1:(k-1), function(x) tmixture.matrix(modt1[x,], 
   sqrt(1/n), n+nu-1, prop, c(0.1, 4)^2/Lambda1[x,x]))^(-1))

   res$M <- mydata
   res$prop <- prop
   res$nu <- nu
   res$Lambda1 <- Lambda1 
   res$eta <- eta

 
   if(nu < 0) stop("The degrees of moderation <0 !")
   
   tol <- .Machine$double.eps
   if(is.finite(nu) & nu > tol)
   {
      MB <- NULL
      if(T2.only==FALSE)
      {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- ((k-1)/2)*log((eta/(n+eta)),10)
      MB3 <- ((n+nu)/2)*log(((n-1+nu+HotellingT2)/(n-1+nu+(eta/(n+eta))*HotellingT2)), 10)
      MB <- MB1+MB2+MB3
      }
      unique.n <- unique(n)
      res$percent <- matrix(c(unique.n, round(100*nu/(nu+unique.n-1))), ncol=2)
      res$size <- n
      res$con.group <- rep(1, k*max.n)
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt1 <- modt1
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }

   if(is.infinite(nu))
   {
      MB <- NULL
      if(T2.only==FALSE)
      {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- ((k-1)/2)*log((eta/(n+eta)),10)
      MB3 <- 0.5*(n/(n+eta))*HotellingT2-log(10)
      MB <- MB1+MB2+MB3
      }

      unique.n <- unique(n)
      res$percent <- matrix(c(unique.n, 100), ncol=2)
      res$size <- n
      res$con.group <- rep(1, k*max.n)
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt1 <- modt1
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }

   if(nu < tol & nu >=0)
   {
      MB <- NULL
      if(T2.only==FALSE)
      {
      MB1 <- log(prop,10)-log(1-prop,10)
      MB2 <- ((k-1)/2)*log((eta/(n+eta)),10)
      MB3 <- (n/2)*log(((n-1+HotellingT2)/(n-1+(eta/(n+eta))*HotellingT2)), 10)
      MB <- MB1+MB2+MB3
      }

      unique.n <- unique(n)
      res$percent <- matrix(c(unique.n, 0), ncol=2)
      res$size <- n
      res$con.group <- rep(1, k*max.n)
      res$rep.group <- n.grp
      res$time.group <- k.grp
      if(r) res$weights <- wt
      if(vec) res$modt1 <- modt1
      res$HotellingT2 <- HotellingT2 
      res$MB <- MB
   }
    
   res$pos.HotellingT2 <- order(HotellingT2, decreasing = TRUE)
   if(!is.null(MB)) res$pos.MB <- order(MB, decreasing = TRUE)
   res$geneNames <- geneNames
   res$descriptions <- desc
   new("MArrayTC", res)
   
}

% -*- mode: noweb;noweb-font-lock-mode: R-mode; -*-
%
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.
%
% \VignetteIndexEntry{timecourse manual}
% \VignetteDepends{timecourse}
% \VignetteKeywords{timecourse}
% \VignettePackage{timecourse}
\documentclass[11pt]{article}

\usepackage{amsmath,fullpage}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}
\SweaveOpts{echo=FALSE}
\usepackage{a4wide}

\parindent 0in

\bibliographystyle{abbrvnat}

\begin{document}

\title{\bf The timecourse Package}

\author{Yu Chuan Tai}

\maketitle

\begin{center}
Institute for Human Genetics, University of California, San Francisco \\ 
{\tt taiy@humgen.ucsf.edu}
\end{center}

\tableofcontents



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Overview}

The {\tt timecourse} package aims to serve as
a comprehensive library for the analysis of developmental microarray time course data. 
The current version includes functions for identifying genes of interest from 
longitudinal replicated developmental microarray time course experiments with one or more biological 
conditions.
The main functions are {\bf mb.long()} and {\bf mb.MANOVA()}. 
They calculate the $MB$-statistics and/or
$\widetilde{T}^2$ statistics derived in \cite{TaiSpeed2006} and 
\cite{Taithesis2005}, using multivariate 
empirical Bayes 
approaches. The input object for {\bf mb.long()} and {\bf mb.MANOVA()}
can be a {\tt matrix}, {\tt MAList}, {\tt marrayNorm}, 
or {\tt ExpressionSet}, containing properly preprocessed $log_2$ expression values or ratios.
\par
The multivariate empirical Bayes models proposed in \cite{TaiSpeed2006}
and \cite{Taithesis2005} 
have the advantage over the traditional $F$-statistic in that they 
incorporate
replicate variances, the correlations among gene expression time point samples from longitudinal data, 
and moderation borrowing
the information across genes into the analysis to reduce the numbers of false positives and false
negatives induced by those poorly estimated variance-covariance matrices.
Please see \cite{TaiSpeed2006}, \cite{Tai2005}, and \cite{Taithesis2005} for more details.  
The results from {\bf mb.long()} and {\bf mb.MANOVA()}
are stored in a list object of class {\tt MArrayTC}, 
which contains various useful information and is used as the input object
for the plotting function {\bf plotProfile()}. {\tt MArrayTC} is a subclass of the
virtual class {\tt LargeDataObject} defined in package {\tt limma} \citep{Smyth2004, Smyth2005}
and inherits a show method there.
For more information, type
<<echo=TRUE,print=FALSE>>=
library(timecourse) # load timecourse library
@
\begin{Schunk}
\begin{Sinput}
>help("MArrayTC-class") # look at the help files
>help(mb.long)
>help(mb.MANOVA)
\end{Sinput}
\end{Schunk}

\section{Longitudinal one-sample problem}
\subsection{Data}
The dataset used in the example was generated by \cite{Tomancak2002}. 
Samples from {\it Drosophila} embryos were collected and hybridized onto
Affymetrix chips at hours 1 to 12 post egg laying. The same procedure was 
conducted on 3 different days, yielding 3 replicates and 12 time points.
Since mRNA samples at different times were extracted from different
embryos, it is not a {\it true}
longitudinal design. However, since parallel and identically treated
embryos within
each experiment were very similar, sampling these embryos within each
experiment
at different time points may approximate a longitudinal study.
Therefore, we treat this dataset as longitudinal and proceed with the
one-sample statistic calculated from {\bf mb.long()}.

The dataset has been preprocessed using RMA algorithm \citep{Irizarry2003, Bolstad2003} 
and $log_2$ expression values
were extracted from the RMA output. To reduce the computational time, 
we only include the first 2000 probesets in our demonstration.  

\subsection{Genes of interest}
Suppose we are interested in genes which change over time, the following codes give it a quick start:

1. Assign time and replicate group to each array: 

The default of {\bf mb.long()} assumes the columns (arrays) of the expression 
matrix from the input object are arranged in the order of biological conditions,
replicates and times. 
For the one-sample problem, we only have 1 biological condition, so
the function assumes the columns are arranged in the order of replicates
and times.
Hence, if the 3 replicates are named as {\tt A}, {\tt B}, and {\tt C}, 
the following column arrangement of the matrix {\tt fruitfly} will be the same as the default.  

<<echo=TRUE,print=FALSE>>=
data(fruitfly)
dim(fruitfly)
colnames(fruitfly)
gnames <- rownames(fruitfly)
@

The number of time points and sample sizes are always required as inputs.
If the arrays are not in the default order, one needs to assign the time and 
replicate groups for each array. 
In our example, they are in the default order, so we make the assignments just for demo purpose.
<<echo=TRUE,print=FALSE>>=
assay <- rep(c("A", "B", "C"), each=12)
time.grp <- rep(c(1:12), 3)
size <- rep(3, 2000)
@ 

2. Calculate the $MB$-statistics and $\widetilde{T}^2$ statistics, and plot individual genes of interest.
<<echo=TRUE,print=FALSE>>=
out1 <- mb.long(fruitfly, times=12, reps=size)
out2 <- mb.long(fruitfly, times=12, reps=size, rep.grp=assay, time.grp=time.grp)
@

\section{Longitudinal two-sample problem}
\subsection{Data}
Now we simulate a dataset with two biological conditions.
There are 1000 genes in total, and 20 of them have the same expected time course profiles
between these two biological conditions.  
Each gene has 3 time course replicates and 5 time points for each condition.
Note that this simulation is for demonstration purpose only,
and does not necessarily reflect the real 
features of longitudinal time course data.

<<echo=TRUE,print=FALSE>>=
SS <- matrix(c( 1e-02, -8e-04, -0.003,  7e-03,  2e-03,
               -8e-04,  2e-02,  0.002, -4e-04, -1e-03,
               -3e-03,  2e-03,  0.030, -5e-03, -9e-03,
                7e-03, -4e-04, -0.005,  2e-02,  8e-04,
                2e-03, -1e-03, -0.009,  8e-04,  7e-02), ncol=5)

sim.Sigma <- function()
{
    S <- matrix(rep(0,25),ncol=5)
    x <- mvrnorm(n=10, mu=rep(0,5), Sigma=10*SS)
    for(i in 1:10)
       S <- S+crossprod(t(x[i,]))

       solve(S)

}


sim.data2 <- function(x, indx=1)
{
    mu <- rep(runif(1,8,x[1]),5)
    if(indx==1)
       res <- c(as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=5), Sigma=sim.Sigma()))),
                  as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=3.2), Sigma=sim.Sigma()))))

     if(indx==0) res <- as.numeric(t(mvrnorm(n=6, mu=mu+rnorm(5,sd=3), Sigma=sim.Sigma())))
       res 
}

M2 <- matrix(rep(14,1000*30), ncol=30)
M2[1:20,] <- t(apply(M2[1:20,],1,sim.data2))
M2[21:1000,] <- t(apply(M2[21:1000,],1,sim.data2, 0)) 
@ 

\subsection{Genes of interest: paired two-sample problem}
Assume it is a paired two-sample problem, we can do the following.
Note that, R is case-sensitive and since
{\tt mt} $<$ {\tt wt }, the first column of the input argument {\tt reps} should be the sample
sizes of all genes for {\tt mt}, while the second column is
those for {\tt wt}. The same rule applies for the input argument {\tt size} for {\bf mb.MANOVA()}.
 
<<echo=TRUE,print=FALSE>>=
trt <- rep(c("wt","mt"),each=15)
assay <- rep(rep(c("rep1","rep2","rep3"),each=5),2)
size <- matrix(3, nrow=1000, ncol=2)
MB.paired <- mb.long(M2, method="paired", times=5, reps=size, condition.grp=trt, rep.grp=assay)
genenames <- as.character(1:1000)
@ 

\subsection{Genes of interest: independent two-sample problem}
Now assume it is an independent two-sample problem
<<echo=TRUE,print=FALSE>>=
MB.2D <- mb.long(M2, method="2", times=5, reps=size, condition.grp=trt, rep.grp=assay)
@  

\section{Longitudinal multi-sample problem}
\subsection{Data}
Now let's simulate a dataset with three biological conditions
500 genes in total, 10 of them have different expected time course profiles
across biological conditions:
the first condition has 3 replicates, while the second condition has 4 replicates,
and the third condition has 2 replicates. 5 time points for each condition.

<<echo=TRUE,print=FALSE>>=
sim.data <- function(x, indx=1)
{
   mu <- rep(runif(1,8,x[1]),5)
   if(indx==1)
     res <- c(as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=5), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=4, mu=mu+rnorm(5,sd=3.2), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=2, mu=mu+rnorm(5,sd=2), Sigma=sim.Sigma()))))

   if(indx==0) res <- as.numeric(t(mvrnorm(n=9, mu=mu+rnorm(5,sd=3), Sigma=sim.Sigma())))
   res
}

M <- matrix(rep(14,500*45), ncol=45)
M[1:10,] <- t(apply(M[1:10,],1,sim.data))
M[11:500,] <- t(apply(M[11:500,],1,sim.data, 0))
@
\subsection{Genes of interest}
The following codes show an example of
identifying genes with different temporal profiles across biological conditions: 
<<echo=TRUE,print=FALSE>>=
assay <- rep(c("1.2.04","2.4.04","3.5.04","5.21.04","7.17.04","9.10.04","12.1.04","1.2.05","4.1.05"),each=5)
trt <- c(rep(c("wildtype","mutant1"),each=15),rep("mutant1",5), rep("mutant2", 10))

# Caution: since "mutant1" < "mutant2" < "wildtype", the sample sizes should be in the order of 4,2,3,
# but NOT 3,4,2.
size <- matrix(c(4,2,3), byrow=TRUE, nrow=500, ncol=3)
MB.multi <- mb.MANOVA(M, times=5, D=3, size=size, rep.grp=assay, condition.grp=trt)
@             
\section{The amount of moderation}
It is always a good idea to check the amount of moderation, which
is determined by the diagonal elements of the (transformed)
gene-specific (pooled) variance-covariance matrices.
The more homogenous these diagonal elements are across genes, the larger the amount of moderation will
occur.
Try different values of the input argument {\bf prior.df} to see what happens.
\section{Which Statistic?}
In the one- and two- sample longitudinal problems, when the sample size(s) are {\it different} across 
genes, the $MB$-statistics are the ones
you should use for ranking. 
Otherwise, the $MB$-statistics and $\widetilde{T}^2$ produce 
the same ranking. 
\section{Missing data}
For version 1.0.0, 
missing time point samples are not allowed in {\bf mb.long()} 
and {\bf mb.MANOVA()}, while missing
replicates are allowed for a subset of genes. In the latter case, the user still
need to input a complete data matrix with missing replicates indicated by NAs. 
<<echo=TRUE,print=FALSE>>=
fruitfly[6, 13:24] <- NA  # The 6th gene has 1 missing replicate
size <- rep(3, 2000)
size[6] <- 2
MB.missing <- mb.long(fruitfly, times=12, reps=size, HotellingT2.only=FALSE)
@ 
\section{Outliers}
When type$=$robust, the numerator of the $\widetilde{T}^2$ statistic is calculated using
the weighted average time course vector(s), where the weight for
each data point is determined by
Huber's weight function \citep{Huber1981, Fox2002} with the default tuning constant 1.345.
\par
When there are only 2 replicates within conditions,
type$=$robust produces the same rankings as type$=$none
since there is no concensus on gene expression values.
We recommend that at least 3 replicates should be performed
when designing an experiment so that
outliers can be determined by concensus.  
Check the output weights for these outliers.
%%\SweaveOpts{echo=true}
\section{Acknowledgements}
The {\tt timecourse} package has greatly benefited from many critical comments by Terry Speed.
The {\it Drosophila} data were provided by Pavel Tomancak and his colleagues.
Thanks are also due to Ben Bolstad for his advices on building up this package, and 
Karen Vranizan, Yun Zhou, Jun Li and their Pritzker colleagues, and Soyeon Ahn for using the test 
version of this package and their helpful feedbacks.
\bibliography{timecourse}
\section{Temporal profile plots}
The temporal profile(s) for any single gene can be plotted using the {\tt plotProfile()} with
the resulting {\tt MArrayTC} object as the input, see below 
for examples. The user can either specify the rank or the gene ID of the gene to be plotted.
\begin{figure}[htbp]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
## plots the no. 1 gene
plotProfile(out2, type="b", gnames=gnames, legloc=c(2,15), pch=c("A","B","C"), xlab="Hour")
@
\end{center}
\caption{The no. 1 gene of {\it fruitfly}.}
\end{figure}

\begin{figure}[htbp]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
## plots the no. 100 gene
plotProfile(out2, type="b", gnames=gnames, pch=c("A","B","C"), xlab="Hour", ranking=100)
@ 
\end{center}
\caption{The no. 100 gene of {\it fruitfly}}
\end{figure}
\begin{figure}[htbp]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
## plots the gene 141404_at
plotProfile(out2, type="b", gnames=gnames, pch=c("A","B","C"), xlab="Hour", gid="141404_at")

@ 
\end{center}
\caption{Gene 141404\_at in {\it fruitfly}}
\end{figure}

\begin{figure}[htbp]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
plotProfile(MB.paired,type="b", gnames=genenames)
@ 
\end{center}
\caption{The no. 1 gene for paired two-sample problem.}
\end{figure}

\begin{figure}[htbp]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
plotProfile(MB.2D,type="b", gnames=genenames)
@ 
\end{center}
\caption{The no. 1 gene for independent two-sample problem.}
\end{figure}
\begin{figure}[htbp]   
\begin{center}
<<fig=TRUE,echo=TRUE>>=
plotProfile(MB.multi, stats="MB", type="b")
@
\end{center}
\caption{The no. 1 gene for multi-sample problem.}
\end{figure}
\begin{figure}[h]
\begin{center}
<<fig=TRUE,echo=TRUE>>=
plotProfile(MB.missing, stats="MB", type="b", gid="141205_at", 
gnames=gnames,pch=c("A","B","C"))
@ 
\end{center}
\caption{The gene 141205\_at in fruitfly: one replicate is missing.}
\end{figure}
\end{document}

\name{fruitfly}
\docType{data}
\alias{fruitfly}
\title{Drosophila microarray time course data in Tomancak et al. (2002)}
\description{
This is a subset of the Drosophila microarray time course data in
Tomancak et al. (2002). 
}
\usage{data(fruitfly)}
\format{A matrix of \eqn{log_2} gene expression values for 2000 probesets.}
\source{
Tomancak et al. (2002) \emph{Systematic determination of patterns of gene expression during 
Drosophila embryogenesis.}
Genome Biology 2002, 3:research0088.1-0088.14
\url{http://genomebiology.com/2002/3/12/research/0088.1}
The complete dataset can be downloaded from the following website
\url{http://www.fruitfly.org/cgi-bin/ex/insitu.pl}
}

\keyword{datasets}

\name{mb.MANOVA}
\alias{mb.MANOVA}

\title{Multivariate Empirical Bayes Analysis of Variance for Longitudinal Replicated 
Developmental Microarray Time Course Data}
\description{Computes the MB-statistics for longitudinal replicated developmental microarray time course 
data with multiple biological conditions.}
\usage{
mb.MANOVA(object, times, D, size, nu = NULL, Lambda = NULL, 
beta.d = NULL, beta = NULL, alpha.d = NULL, alpha = NULL, 
condition.grp, time.grp = NULL, rep.grp = NULL, p = 0.02)
}
\arguments{
  \item{object}{Required. An object of class \code{matrix}, \code{MAList},
    \code{marrayNorm}, or \code{ExpressionSet} containing log-ratios or
    log-values of expression for a series of microarrays.} 
  \item{times}{Required. A positive integer giving the number of time points.}
  \item{D}{Required. A positive integer giving the number of biological conditions. \code{D>1}}
  \item{size}{Required. A numeric matrix corresponding to the sample sizes for all genes across
          different biological conditions, when biological conditions are sorted in ascending order.
          Rows represent genes while columns represent biological conditions.}
  \item{nu}{an optional positive value giving the degrees of moderation for the fully moderated Wilks' 
Lambda.}  
  \item{Lambda}{an optional numeric matrix giving the common covariance matrix for the fully
   moderated Wilks' Lambda.}
  \item{beta.d}{an optional numeric vector of length \code{D} giving the condition-specific scale 
parameters for the common covariance matrix of the expected time course vectors under the alternative.}
  \item{beta}{an optional numeric value giving the scale parameter for the common covariance matrix of
  the common expected time course vector under the null.}
  \item{alpha.d}{an optional numeric matrix giving the condition-specific means of the expected
  time course vectors under the alternative.}
  \item{alpha}{an optional numeric vector of length \code{times} giving the common mean of the 
 expected time course vector under the null.}
\item{condition.grp}{Required. A numeric or character vector with length equals to the number of arrays,
assigning the biological condition group to each array.}
  \item{rep.grp}{an optional numeric or character vector with length equals to the number of arrays,
assigning the replicate group to each array.}
  \item{time.grp}{an optional numeric vector with length equals to the number of arrays,
assigning the time point group to each array.}
  \item{p}{a numeric value between 0 and 1, assumed proportion of genes
which are differentially expressed.}
}
\value{

Object of \code{MArrayTC}.
  
}
\details{
  This function implements the multivariate empirical Bayes Analysis
  of Variance model for identifying genes with different temporal
  profiles across multiple biological conditions,
  as described in Tai (2005).  
  
}
\seealso{
timecourse Vignette.
}
\author{Yu Chuan Tai  \email{yuchuan@stat.berkeley.edu}}
\references{
Yu Chuan Tai (2005). Multivariate empirical Bayes models for replicated microarray time course data.
Ph.D. dissertation. Division of Biostatistics, University of California, Berkeley.

Yu Chuan Tai and Terence P. Speed (2005). Statistical analysis of microarray time course data. In: DNA 
Microarrays, U. Nuber (ed.), BIOS Scientific Publishers Limited, Taylor & Francis, 4 Park Square, Milton 
Park, Abingdon OX14 4RN, Chapter 20. 
}
\examples{

SS <- matrix(c(    0.01, -0.0008,   -0.003,     0.007,  0.002,
                -0.0008,    0.02,    0.002,   -0.0004, -0.001,
                 -0.003,   0.002,     0.03,   -0.0054, -0.009,
                  0.007, -0.0004, -0.00538,      0.02, 0.0008,
                  0.002,  -0.001,   -0.009,    0.0008,  0.07), ncol=5)

sim.Sigma <- function()
{
   S <- matrix(rep(0,25),ncol=5)
   x <- mvrnorm(n=10, mu=rep(0,5), Sigma=10*SS)
   for(i in 1:10)
       S <- S+crossprod(t(x[i,]))

   solve(S)

}

## Now let's simulate a dataset with three biological conditions
## 500 genes in total, 10 of them have different expected time course profiles
## across biological conditions
## the first condition has 3 replicates, while the second condition has 4 replicates, 
## and the third condition has 2 replicates. 5 time points for each condition.

sim.data <- function(x, indx=1)
{
   mu <- rep(runif(1,8,x[1]),5)
   if(indx==1)
     res <- c(as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=5), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=4, mu=mu+rnorm(5,sd=3.2), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=2, mu=mu+rnorm(5,sd=2), Sigma=sim.Sigma()))))

   if(indx==0) res <- as.numeric(t(mvrnorm(n=9, mu=mu+rnorm(5,sd=3), Sigma=sim.Sigma())))
   res
}

M <- matrix(rep(14,500*45), ncol=45)
M[1:10,] <- t(apply(M[1:10,],1,sim.data))
M[11:500,] <- t(apply(M[11:500,],1,sim.data, 0))


assay <- rep(c("1.2.04","2.4.04","3.5.04","5.21.04","7.17.04","9.10.04","12.1.04","1.2.05","4.1.05"),each=5)
trt <- c(rep(c("wildtype","mutant1"),each=15),rep("mutant1",5), rep("mutant2", 10))

# Caution: since "mutant1" < "mutant2" < "wildtype", the sample sizes should be in the order of 4,2,3, 
# but NOT 3,4,2. 
size <- matrix(c(4,2,3), byrow=TRUE, nrow=500, ncol=3)
MB.multi <- mb.MANOVA(M, times=5, D=3, size=size, rep.grp=assay, condition.grp=trt)

plotProfile(MB.multi, stats="MB", type="b") # plots the no. 1 gene
}
\keyword{multivariate}

\name{mb.long}
\alias{mb.long}
\alias{mb.1D}
\alias{mb.paired}
\alias{mb.2D}

\title{Multivariate Empirical Bayes Statistics for Longitudinal Replicated Developmental Microarray Time 
Course Data}
\description{Computes the \eqn{\tilde{T}^2} statistics and/or the 
MB-statistics of differential expression for longitudinal replicated developmental microarray time course 
data by multivariate empirical Bayes shrinkage of gene-specific sample variance-covariance matrices
towards a common matrix.}
\usage{
mb.long(object, method = c("1D", "paired", "2D"), type = c("none", "robust"), 
times, reps, prior.df = NULL, prior.COV = NULL, 
prior.eta = NULL, condition.grp = NULL, rep.grp = NULL, time.grp = NULL, 
one.sample = FALSE, ref = NULL, p = 0.02, out.t = FALSE, 
tuning = 1.345, HotellingT2.only=TRUE)
}
\arguments{
  \item{object}{Required. An object of class \code{matrix}, \code{MAList},
    \code{marrayNorm}, or \code{ExpressionSet} containing log-ratios or
    log-values of expression for a series of microarrays.}
  \item{method}{a character string, \code{"1D"} for the one-sample case where genes
                of interest are those which change over time,  
                \code{"paired"} for the one-sample case where genes of interest are
		those whose expected temporal profiles do not stay 0, for example, cDNA microarrays, 
                or the paired two-sample case where genes of interest are those with different
                expected temporal profiles across 2 biological conditions,
                \code{"2D"} for the independent two-sample case where genes of interest are those
                with different expected temporal profiles across 2 biological conditions.
                The default is \code{"1D"}.}
  \item{type}{a character string, indicating whether possible outliers should be down-weighted.} 
  \item{times}{Required. A positive integer giving the number of time points.}
  \item{reps}{Required. A numeric vector or matrix corresponding to the sample sizes for all 
          genes across different biological conditions, when biological conditions are sorted in 
          ascending order. If a matrix, rows represent genes while columns represent biological conditions.}
  \item{prior.df}{an optional positive value giving the degrees of moderation.}  
  \item{prior.COV}{an optional numeric matrix giving the common covariance matrix
    to which the gene-specific sample covariances are smoothed toward.}  
  \item{prior.eta}{an optional numeric value giving the scale parameter for the covariance matrix for
   the expected time course profile.}
  \item{condition.grp}{a numeric or character vector with length equals to the number of arrays,
                       assigning the biological condition group of each array. Required if 
                       \code{method=2D}.}
  \item{rep.grp}{an optional numeric or character vector with length equals to the number of arrays,
                 assigning the replicate group of each array.}
  \item{time.grp}{an optional numeric vector with length equals to the number of arrays,
                 assigning the time point group of each array.}
  \item{one.sample}{Is it a one-sample problem? Only specify this argument when \code{method=paired}. 
                    The default is \code{FALSE} which means it is a paired two-sample problem.}
  \item{ref}{an optional numeric value or character specifying the name
          of reference biological condition. The default uses the
          first element of \code{condition.grp}. Only specify this argument when
          \code{method=paired} and \code{one.sample} is \code{FALSE}.}
  \item{p}{a numeric value between 0 and 1, assumed proportion of genes
          which are differentially expressed.}
  \item{out.t}{logical. Should the moderated multivariate t-statistics be outputed? The default is 
  \code{FALSE}.}
  \item{tuning}{the tuning constant for the Huber weight function with a default 1.345.}
  \item{HotellingT2.only}{logical. Should only the HotellingT2 statistics be outputed? This should be 
set as \code{TRUE} (default) when the sample size(s) are the same across genes, in order to reduce
computational time.}
}
\value{
Object of \code{MArrayTC}.
}
\details{
  This function implements the multivariate empirical Bayes statistics
  described in Tai and Speed (2004), to rank genes in the order of
  interest from longitudinal replicated developmental microarray time course
  experiments. It calls one of the following functions, 
  depending on which \code{method} is used: \code{mb.1D}, 
  \code{mb.paired}, and \code{mb.2D}.

  The arguments \code{condition.grp}, \code{rep.grp}, and
  \code{time.grp}, if specified, should have lengths equal to the number
  of arrays. The \eqn{i_th} elements of these three arguments should
  correspond to the biological condition, replicate, and time for the \eqn{i_th} column (array) in the
  expression value matrix of the input object, respectively.
  The default assumes the columns of \code{M} are in the ascending order of \code{condition.grp} first,
  and then \code{rep.grp}, and finally \code{time.grp}. 
 
  Arguments \code{one.sample} and \code{ref} are for \code{method=paired} only.

  When \code{type=robust}, the numerator of the \eqn{\tilde{T}^2} statistic is calculated using
  the weighted average time course vector(s), where the weight at each data point 
  is determined using Huber's weight function with the default tuning constant 1.345.

  Warning: When there are only 2 replicates within conditions,
           \code{type="robust"} produces the same rankings as \code{type="none"} 
           since there is no consensus on gene expression values. 
           Check the output weights for these outliers.   
}
\seealso{
timecourse Vignette.
}
\author{Yu Chuan Tai  \email{yuchuan@stat.berkeley.edu}}
\references{
Yu Chuan Tai and Terence P. Speed (2006). A multivariate empirical Bayes statistic
for replicated microarray time course data. Annals of Statistics 34(5):2387-2412. 

Yu Chuan Tai and Terence P. Speed (2005). Statistical analysis of microarray time course data. In: DNA 
Microarrays, U. Nuber (ed.), BIOS Scientific Publishers Limited, Taylor & Francis, 4 Park Square, Milton 
Park, Abingdon OX14 4RN, Chapter 20. 

P. J. Huber (2004). Robust Statistics. 
\emph{Wiley series in probability and mathematical statistics}.
}
\examples{
data(fruitfly)
colnames(fruitfly) ## check if arrays are arranged in the default order
gnames <- rownames(fruitfly)
assay <- rep(c("A", "B", "C"), each = 12)
time.grp <- rep(c(1:12), 3)
size <- rep(3, nrow(fruitfly))

out1 <- mb.long(fruitfly, times=12, reps=size, rep.grp = assay, time.grp = time.grp)
summary(out1)
plotProfile(out1, type="b", gnames=gnames, legloc=c(2,15), pch=c("A","B","C"), xlab="Hour")

## Simulate gene expression data
## Note: this simulation is for demonstration purpose only,
## and does not necessarily reflect the real 
## features of longitudinal time course data

## one biological condition, 5 time points, 3 replicates
## 500 genes, 10 genes change over time

SS <- matrix(c(    0.01, -0.0008,   -0.003,     0.007,  0.002,
                -0.0008,    0.02,    0.002,   -0.0004, -0.001,
                 -0.003,   0.002,     0.03,   -0.0054, -0.009,
                  0.007, -0.0004, -0.00538,      0.02, 0.0008,
                  0.002,  -0.001,   -0.009,    0.0008,  0.07), ncol=5)

sim.Sigma <- function()
{
   S <- matrix(rep(0,25),ncol=5)
   x <- mvrnorm(n=10, mu=rep(0,5), Sigma=10*SS)
   for(i in 1:10)
       S <- S+crossprod(t(x[i,]))

   solve(S)

}

sim.data1 <- function(x, indx=1)
{
   mu <- rep(runif(1,8,x[1]),5)
   if(indx==1) res <- as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=4), Sigma=sim.Sigma())))
   if(indx==0) res <- as.numeric(t(mvrnorm(n=3, mu=mu, Sigma=sim.Sigma())))
   res
}

M1 <- matrix(rep(14,500*15), ncol=15)
M1[1:10,] <- t(apply(M1[1:10,],1,sim.data1))
M1[11:500,] <- t(apply(M1[11:500,],1,sim.data1, 0))

## Which genes are nonconstant?
MB.1D1 <- mb.long(M1, times=5, reps=rep(3, 500))
MB.1D1$percent  # check the percent of moderation

plotProfile(MB.1D1,type="b") # plots the no. 1 gene
plotProfile(MB.1D1,type="b",ranking=10) # plots the no. 10 gene
genenames <- as.character(1:500)
plotProfile(MB.1D1, type="b", gid="8", gnames=genenames) #plots the gene with ID "8"

## 
MB.1D1.r <- mb.long(M1, type="r", times=5, reps=rep(3, 500))
plotProfile(MB.1D1.r,type="b",gnames=genenames)
plotProfile(MB.1D1.r,type="b", gid="1", gnames=genenames) #plots the gene with ID "1" 

## assign the following labellings to columns of M1
## which is actually the same as the default
## Not Run
trt <- rep("wildtype", 15)
assay <- rep(c("A","B","C"), rep(5,3))
time.grp <- rep(c(0, 1, 3, 4, 6), 3)

## MB.1D2 should give the same results as MB.1D1
#MB.1D2 <- mb.long(M1, times=5, reps=rep(3, 500), condition.grp = trt, rep.grp = assay, 
#time.grp=time.grp)

## suppose now the replicates are in this order instead
assay <- rep(c("A","C","B"), rep(5,3))

## then
MB.1D3 <- mb.long(M1, times=5, reps=rep(3, 500), condition.grp = trt, rep.grp = assay, time.grp=time.grp)
MB.1D3$rep.group  #check the replicate and time group
MB.1D3$time.group


## Now let's simulate another dataset with two biological conditions
## 500 genes also, 10 of them have different expected time course profiles
## between these two biological conditions  
## 3 replicates, 5 time points for each condition

sim.data2 <- function(x, indx=1)
{
   mu <- rep(runif(1,8,x[1]),5)
   if(indx==1)
     res <- c(as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=5), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=3.2), Sigma=sim.Sigma()))))

   if(indx==0) res <- as.numeric(t(mvrnorm(n=6, mu=mu+rnorm(5,sd=3), Sigma=sim.Sigma())))
   res 
}

M2 <- matrix(rep(14,500*30), ncol=30)
M2[1:10,] <- t(apply(M2[1:10,],1,sim.data2))
M2[11:500,] <- t(apply(M2[11:500,],1,sim.data2, 0))

## assume it is a paired two-sample problem
trt <- rep(c("wt","mt"),each=15)
assay <- rep(rep(c("1.2.04","2.4.04","3.5.04"),each=5),2)
size <- matrix(3, nrow=500, ncol=2)
MB.paired <- mb.long(M2, method="paired", times=5, reps=size, condition.grp=trt, rep.grp=assay)
MB.paired$con.group # check the condition, replicate and time groups
MB.paired$rep.group
MB.paired$time.group

plotProfile(MB.paired, type="b")
genenames <- as.character(1:500)
plotProfile(MB.paired, gid="12", type="b", gnames=genenames) #plots the gene with ID "12"

### assume it is a unpaired two-sample problem
assay <- rep(c("1.2.04","2.4.04","3.5.04","5.21.04","7.17.04","8.4.04"),each=5)
MB.2D <- mb.long(M2, method="2", times=5, reps=size, condition.grp=trt, rep.grp=assay)
MB.2D$con.group # check the condition, replicate and time groups
MB.2D$rep.group
MB.2D$time.group 

plotProfile(MB.2D,type="b", gnames=genenames) # plot the no. 1 gene


## Now let's simulate another dataset with two biological conditions
## 500 genes also, 10 of them have different expected time course profiles
## between these two biological conditions
## the first condition has 3 replicates, while the second condition has 4 replicates, 
## 5 time points for each condition

sim.data3 <- function(x, indx=1)
{
   mu <- rep(runif(1,8,x[1]),5)
   if(indx==1)
     res <- c(as.numeric(t(mvrnorm(n=3, mu=mu+rnorm(5,sd=5), Sigma=sim.Sigma()))),
             as.numeric(t(mvrnorm(n=4, mu=mu+rnorm(5,sd=3.2), Sigma=sim.Sigma()))))

   if(indx==0) res <- as.numeric(t(mvrnorm(n=7, mu=mu+rnorm(5,sd=3), Sigma=sim.Sigma())))
   res
}

M3 <- matrix(rep(14,500*35), ncol=35)
M3[1:10,] <- t(apply(M3[1:10,],1,sim.data3))
M3[11:500,] <- t(apply(M3[11:500,],1,sim.data3, 0))

assay <- rep(c("1.2.04","2.4.04","3.5.04","5.21.04","7.17.04","9.10.04","12.1.04"),each=5)
trt <- c(rep(c("wildtype","mutant"),each=15),rep("mutant",5))
## Note that "mutant" < "wildtype", the sample sizes are (4, 3)
size <- matrix(c(4,3), nrow=500, ncol=2, byrow=TRUE)
MB.2D.2 <- mb.long(M3, method="2", times=5, reps=size, rep.grp=assay, condition.grp=trt)
MB.2D.2$con.group # check the condition, replicate and time groups
MB.2D.2$rep.group
MB.2D.2$time.group 

plotProfile(MB.2D.2, type="b") # plot the no. 1 gene
}
\keyword{multivariate}

\name{univ.func}
\alias{univ.func}

\title{Univariate Data}
\description{Transforms multivariate vectors into univariate values using the Helmert matrix.}
\usage{
univ.func(dummy, M, k, n, indx = 1)
}
\arguments{
  \item{dummy}{a numeric gene index.}
  \item{M}{a numeric matrix containing the log-values or log-ratios of a gene.}
  \item{k}{a positive integer giving the number of time points.}
  \item{n}{a positive integer giving the number of replicates.}
  \item{indx}{a positive integer between 1 and k, indicating which row of the Helmert
  matrix to transform the vectors.}
}
\value{
A numeric vector with length equals to \code{n}.
}

\details{
This function is for internal use only and is not to be called by the user.
}

\seealso{
\code{\link{ot.helmert}}.
}


\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}
\keyword{univar}

\name{ot.helmert}
\alias{ot.helmert}

\title{Helmert orthogonal transformation}
\description{Computes the Helmert orthogonal transformation matrix.}
\usage{
ot.helmert(k)
}
\arguments{
  \item{k}{a positive integer giving the number of time points.}         
}
\value{
a numeric matrix.
}

\details{
This function is for internal use only and is not to be called by the user.
}


\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}
\keyword{array}

\title{Gene Temporal Profile Plot}
\name{plotProfile}
\alias{plotProfile}
\description{
Plots the longitudinal temporal profile of a gene.
}
\usage{
plotProfile(object, stats=c("HotellingT2", "MB"), ranking=1, gid=NULL, gnames=NULL, desc=NULL,
type=c("p","l","b"), col=2:100, lty=1:100, pch=1:100, lwd=2, xlab="Time",
ylab="Expression", legloc=NULL, xlim=NULL, ylim=NULL, cex.main=1,...)
}
\arguments{
  \item{object}{a \code{MArrayTC} object.}
  \item{stats}{a character indicating which statistic the \code{ranking} is based on.}
  \item{ranking}{a numeric value giving the ranking of the gene to be plotted.}
  \item{gid}{an optional character giving the ID of the gene to be plotted.}
  \item{gnames}{an optional character vector with the \eqn{i_th} element corresponds to the gene ID of the \eqn{i_th} gene in \code{object$M}.}
  \item{desc}{an optional character vector with the \eqn{i_th} element corresponds to the gene description of the \eqn{i_th} gene in \code{object$M}.}
  \item{type}{a character indicating the plot type, \code{"p"} for points, \code{"l"} for lines, and \code{"b"} for both.}
  \item{col}{a character or numeric vector giving the colors for different biological conditions. Default is \code{2:100}.}
  \item{lty}{a character or numeric vector giving the line types for different replicates. Default is \code{1:100}.}
  \item{pch}{a character or numeric vector giving the point types for different replicates. Default is \code{1:100}.}
  \item{lwd}{optional. The default sets to 2.}
  \item{xlab}{character. The label for the x-axis.}
  \item{ylab}{character. The label for the y-axis.} 
  \item{legloc}{an optional vector giving the location of the legend.}
  \item{xlim}{an optional vector giving the upper- and lower- limits of x-axis.}
  \item{ylim}{an optional vector giving the upper- and lower- limits of y-axis.}
  \item{cex.main}{optional. The default sets to 1}
  \item{...}{any other arguments passed onto \code{plot}}
}

\details{
This function takes an object of \code{MArrayTC} as the input and plots
the temporal profile of a single gene. The user can specify either the
ranking based on \code{stats} or the gene ID of the gene to be plotted.   

See \code{\link[graphics]{points}} for possible values for \code{pch},
\code{col} and \code{cex}. 

See \code{mb.long} for examples.
}


\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}



\keyword{hplot}

\name{MArrayTC-class}
\docType{class}
\alias{MArrayTC-class}
\alias{LargeDataObject-class}
\title{Microarray Time Course Object- class}

\description{
A list-based class for storing the analysis results from the multivariate
empirical Bayes models of differential expression for longitudinal replicated
developmental microarray time course data.
Objects are normally created by \code{\link{mb.long}} and \code{\link{mb.MANOVA}}.
}

\section{Slots/Components}{
  \code{MArrayTC} objects do not contain any slots (apart from
  \code{.Data}) but they should contain the following list components:
  \describe{
    \item{\code{M}:}{input \code{matrix} of log-ratios or log-values of
      expression for a series of microarrays.}
  }
  Objects may also contain the following optional components:
  \describe{
     \item{\code{prop}:}{\code{numeric} value giving the proportion of
      differentially expressed genes.}
    \item{\code{nu}:}{\code{numeric} value containing the estimated
      amount of moderation.}
    \item{\code{Lambda}:}{the estimated Lambda.}
    \item{\code{Lambda1}:}{the estimated Lambda1.}
    \item{\code{eta}:}{the estimated prior scale parameter.}
    \item{\code{alpha}:}{the estimated common
          mean of the expected time course vector under the null.}
     \item{\code{alpha.d}:}{the estimated condition-specific     
          means of the expected time course vectors under the alternative.}
     \item{\code{beta}:}{the estimated scale parameter for the
          common covariance matrix of the common expected time course
          vector under the null.}
     \item{\code{beta.d}:}{the estimated condition-specific scale parameters for the common
          covariance matrix of the expected time course vectors under
          the alternative.} 
    \item{\code{percent}:}{\code{numeric} matrix containing the percent of moderation 
     corresponding to each sample size for the longitudinal one- and two- sample problems.}
    \item{\code{size}:}{\code{numeric} vector or matrix containing the sample sizes for 
    all genes corresponding to different biological conditions, when the latter are sorted in ascending 
    order.}
    \item{\code{con.group}:}{\code{numeric} or \code{character} vector giving the biological
    condition group of each array. The \eqn{i_th} element of \code{con.group} corresponds to the
    biological condition of the \eqn{i_th} column of \code{M}.}
    \item{\code{rep.group}:}{\code{numeric} or \code{character} vector giving the replicate
    group of each array. The \eqn{i_th} element of \code{rep.group} corresponds to the 
    replicate of the \eqn{i_th} column of \code{M}.}
    \item{\code{time.group}:}{\code{numeric} vector
      giving the time group of each array. The \eqn{i_th} element of \code{time.group} corresponds to the 
    time of the \eqn{i_th} column of \code{M}.}
    \item{\code{HotellingT2}:}{\code{numeric} vector giving the 
    \eqn{\tilde{T}^2} statistics of differential expression.}
    \item{\code{MB}:}{\code{numeric} vector giving the MB-statistics of differential expression.}
    \item{\code{pos.HotellingT2}:}{\code{numeric} vector whose \eqn{i_th} element corresponds to
    the index of the gene with ranking \eqn{i} in \code{HotellingT2}.}
    \item{\code{pos.MB}:}{\code{numeric} vector whose \eqn{i_th} element corresponds to
    the index of the gene with ranking \eqn{i} in \code{MB}.}
    \item{\code{geneNames}:}{\code{character} vector giving gene names.}
    \item{\code{descriptions}:}{\code{character} vector giving gene descriptions.}
  }
}

\section{Methods}{ 
MArrayTC extends the 
\code{\link[limma:LargeDataObject]{LargeDataObject}} class in package limma, and
inherits a \code{show} method from there.

The function \code{plotProfile} takes \code{MArrayTC} as the input argument.
}

\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}


\keyword{classes}

\name{matrix.cov}
\alias{matrix.cov}


\title{Covariance}
\description{For a single gene, computes the transformed or untransformed sample covariance matrix 
if one biological condition, or pooled sample covariance matrix if two or more biological conditions.}
\usage{
matrix.cov(x, k, trans = TRUE, c.grp = NULL, use = "complete.obs")
}
\arguments{
   \item{x}{a numeric vector giving the log-ratios or log-values for a gene, sorted 
           in ascending order by biological condition, replicate, and time groups.}
  \item{k}{a positive integer giving the number of time points.}
  \item{trans}{logical. Should the Helmert transformation be performed?}
  \item{c.grp}{a numeric vector corresponding to the biological condition group for each element of   
\code{x}.}
  \item{use}{character. The same as the \code{use} in stats function \code{cov}. 
             The default uses complete observations.}
}

\details{
This function is for internal use only and is not to be called by the user.
}

\value{
A numeric matrix. 
}

\references{
Becker, R. A., Chambers, J. M. and Wilks, A. R. (1988) \emph{The New S
     Language}. Wadsworth & Brooks/Cole.
}

\seealso{
\code{\link{cov}}, \code{\link{ot.helmert}}.
}

\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}
\keyword{array}

\name{abs2ratio}
\alias{abs2ratio}

\title{Convert log-values to log-ratios}
\description{For a single gene, computes the log ratios between time courses 
from two paired biological conditions.}
\usage{
abs2ratio(x, mn, k, c.grp, reference)
}
\arguments{
  \item{x}{a numeric vector giving the log-values of a gene with two paired biological conditions,
           sorted in ascending order by biological condition, replicate, and time groups.}
  \item{mn}{a numeric matrix giving the sample sizes for the two biological conditions.}
  \item{k}{a positive integer giving the number of time points.}
  \item{c.grp}{an numeric or character vector with length equals to that of \code{x},
                 giving the biological condition group for each element of \code{x}.}
  \item{reference}{a numeric value or character assigning the reference biological condition.}
}
\value{
a numeric vector containing log-ratios between two paired biological conditions.
}

\details{
This function is for internal use only and is not to be called by the user.

}
\seealso{
\code{\link{mb.paired}}.
}

\author{Yu Chuan Tai \email{yuchuan@stat.berkeley.edu}}
\keyword{misc}
